

   MEMBER('Firebird.clw')                                  ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('FIREBIRD001.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('FIREBIRD002.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('FIREBIRD003.INC'),ONCE        !Req'd for module callout resolution
                     END


!!! <summary>
!!! Generated from procedure template - Frame
!!! Wizard Application for D:\dev\C7.2\Firebird\Firebird.dct
!!! </summary>
Main PROCEDURE 

SQLOpenWindow        WINDOW('Initializing Database'),AT(,,208,26),FONT('MS Sans Serif',8,,FONT:regular),CENTER,GRAY,DOUBLE
                       STRING('This process could take several seconds.'),AT(27,12)
                       IMAGE(Icon:Connect),AT(4,4,23,17)
                       STRING('Please wait while the program connects to the database.'),AT(27,3)
                     END

AppFrame             APPLICATION('Application'),AT(,,505,318),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,ICON('WAFRAME.ICO'),MAX,STATUS(-1,80,120,45),SYSTEM,IMM
                       MENUBAR,USE(?Menubar)
                         MENU('&File'),USE(?FileMenu)
                           ITEM('&Print Setup ...'),USE(?PrintSetup),MSG('Setup printer'),STD(STD:PrintSetup)
                           ITEM,SEPARATOR
                           ITEM('E&xit'),USE(?Exit),MSG('Exit this application'),STD(STD:Close)
                         END
                         MENU('&Edit'),USE(?EditMenu)
                           ITEM('Cu&t'),USE(?Cut),MSG('Cut Selection To Clipboard'),STD(STD:Cut)
                           ITEM('&Copy'),USE(?Copy),MSG('Copy Selection To Clipboard'),STD(STD:Copy)
                           ITEM('&Paste'),USE(?Paste),MSG('Paste From Clipboard'),STD(STD:Paste)
                         END
                         MENU('&Browse'),USE(?BrowseMenu)
                           ITEM('Browse the COUNTRY file'),USE(?BrowseCOUNTRY),MSG('Browse COUNTRY')
                           ITEM('Browse the CUSTOMER file'),USE(?BrowseCUSTOMER),MSG('Browse CUSTOMER')
                           ITEM('Browse the DEPARTMENT file'),USE(?BrowseDEPARTMENT),MSG('Browse DEPARTMENT')
                           ITEM('Browse the EMPLOYEE file'),USE(?BrowseEMPLOYEE),MSG('Browse EMPLOYEE')
                           ITEM('Browse the EMPLOYEE_PROJECT file'),USE(?BrowseEMPLOYEE_PROJECT),MSG('Browse EMPLO' & |
  'YEE_PROJECT')
                           ITEM('Browse the JOB file'),USE(?BrowseJOB),MSG('Browse JOB')
                           ITEM('Browse the PHONE_LIST file'),USE(?BrowsePHONE_LIST),MSG('Browse PHONE_LIST')
                           ITEM('Browse the PROJECT file'),USE(?BrowsePROJECT),MSG('Browse PROJECT')
                           ITEM('Browse the PROJ_DEPT_BUDGET file'),USE(?BrowsePROJ_DEPT_BUDGET),MSG('Browse PROJ_' & |
  'DEPT_BUDGET')
                           ITEM('Browse the SALARY_HISTORY file'),USE(?BrowseSALARY_HISTORY),MSG('Browse SALARY_HISTORY')
                           ITEM('Browse the SALES file'),USE(?BrowseSALES),MSG('Browse SALES')
                           ITEM('Browse the DEPARTMENT2 file'),USE(?BrowseDEPARTMENT2),MSG('Browse DEPARTMENT2')
                           ITEM('Browse the DEPARTMENT3 file'),USE(?BrowseDEPARTMENT3),MSG('Browse DEPARTMENT3')
                         END
                         MENU('&Window'),USE(?WindowMenu),STD(STD:WindowList)
                           ITEM('T&ile'),USE(?Tile),MSG('Arrange multiple opened windows'),STD(STD:TileWindow)
                           ITEM('&Cascade'),USE(?Cascade),MSG('Arrange multiple opened windows'),STD(STD:CascadeWindow)
                           ITEM('&Arrange Icons'),USE(?Arrange),MSG('Arrange the icons for minimized windows'),STD(STD:ArrangeIcons)
                         END
                         MENU('&Help'),USE(?HelpMenu)
                           ITEM('&Contents'),USE(?Helpindex),MSG('View the contents of the help file'),STD(STD:HelpIndex)
                           ITEM('&Search for Help On...'),USE(?HelpSearch),MSG('Search for help on a subject'),STD(STD:HelpSearch)
                           ITEM('&How to Use Help'),USE(?HelpOnHelp),MSG('Provides general instructions on using help'), |
  STD(STD:HelpOnHelp)
                         END
                       END
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------
Menu::Menubar ROUTINE                                      ! Code for menu items on ?Menubar
Menu::FileMenu ROUTINE                                     ! Code for menu items on ?FileMenu
Menu::EditMenu ROUTINE                                     ! Code for menu items on ?EditMenu
Menu::BrowseMenu ROUTINE                                   ! Code for menu items on ?BrowseMenu
  CASE ACCEPTED()
  OF ?BrowseCOUNTRY
    START(BrowseCOUNTRY, 050000)
  OF ?BrowseCUSTOMER
    START(BrowseCUSTOMER, 050000)
  OF ?BrowseDEPARTMENT
    START(BrowseDEPARTMENT, 050000)
  OF ?BrowseEMPLOYEE
    START(BrowseEMPLOYEE, 050000)
  OF ?BrowseEMPLOYEE_PROJECT
    START(BrowseEMPLOYEE_PROJECT, 050000)
  OF ?BrowseJOB
    START(BrowseJOB, 050000)
  OF ?BrowsePHONE_LIST
    START(BrowsePHONE_LIST, 050000)
  OF ?BrowsePROJECT
    START(BrowsePROJECT, 050000)
  OF ?BrowsePROJ_DEPT_BUDGET
    START(BrowsePROJ_DEPT_BUDGET, 050000)
  OF ?BrowseSALARY_HISTORY
    START(BrowseSALARY_HISTORY, 050000)
  OF ?BrowseSALES
    START(BrowseSALES, 050000)
  OF ?BrowseDEPARTMENT2
    START(BrowseDEPARTMENT2, 050000)
  OF ?BrowseDEPARTMENT3
    START(BrowseDEPARTMENT3, 050000)
  END
Menu::WindowMenu ROUTINE                                   ! Code for menu items on ?WindowMenu
Menu::HelpMenu ROUTINE                                     ! Code for menu items on ?HelpMenu

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Main')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = 1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SETCURSOR(Cursor:Wait)
  OPEN(SQLOpenWindow)
  ACCEPT
    IF EVENT() = Event:OpenWindow
  Relate:COUNTRY.Open                                      ! File COUNTRY used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
      POST(EVENT:CloseWindow)
    END
  END
  CLOSE(SQLOpenWindow)
  SETCURSOR()
  SELF.Open(AppFrame)                                      ! Open window
  Do DefineListboxStyle
  INIMgr.Fetch('Main',AppFrame)                            ! Restore window settings from non-volatile store
  SELF.SetAlerts()
  COMPILE ('**CW7**',_VER_C70)
      AppFrame{PROP:TabBarVisible}  = False
  !**CW7**
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:COUNTRY.Close
  END
  IF SELF.Opened
    INIMgr.Update('Main',AppFrame)                         ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    ELSE
      DO Menu::Menubar                                     ! Process menu items on ?Menubar menu
      DO Menu::FileMenu                                    ! Process menu items on ?FileMenu menu
      DO Menu::EditMenu                                    ! Process menu items on ?EditMenu menu
      DO Menu::BrowseMenu                                  ! Process menu items on ?BrowseMenu menu
      DO Menu::WindowMenu                                  ! Process menu items on ?WindowMenu menu
      DO Menu::HelpMenu                                    ! Process menu items on ?HelpMenu menu
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the COUNTRY file
!!! </summary>
BrowseCOUNTRY PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(COUNTRY)
                       PROJECT(COU:COUNTRY)
                       PROJECT(COU:CURRENCY)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
COU:COUNTRY            LIKE(COU:COUNTRY)              !List box control field - type derived from field
COU:CURRENCY           LIKE(COU:CURRENCY)             !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the COUNTRY file'),AT(,,224,198),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('BrowseCOUNTRY'),SYSTEM
                       LIST,AT(8,30,208,124),USE(?Browse:1),HVSCROLL,FORMAT('64L(2)|M~COUNTRY~L(2)@s15@44L(2)|' & |
  'M~CURRENCY~L(2)@s10@'),FROM(Queue:Browse:1),IMM,MSG('Browsing the COUNTRY file')
                       BUTTON('&View'),AT(8,158,49,14),USE(?View:2),LEFT,ICON('WAVIEW.ICO'),FLAT,MSG('View Record'), |
  TIP('View Record')
                       BUTTON('&Insert'),AT(61,158,49,14),USE(?Insert:3),LEFT,ICON('WAINSERT.ICO'),FLAT,MSG('Insert a Record'), |
  TIP('Insert a Record')
                       BUTTON('&Change'),AT(114,158,49,14),USE(?Change:3),LEFT,ICON('WACHANGE.ICO'),DEFAULT,FLAT, |
  MSG('Change the Record'),TIP('Change the Record')
                       BUTTON('&Delete'),AT(167,158,49,14),USE(?Delete:3),LEFT,ICON('WADELETE.ICO'),FLAT,MSG('Delete the Record'), |
  TIP('Delete the Record')
                       SHEET,AT(4,4,216,172),USE(?CurrentTab)
                         TAB('&1) INTEG_2'),USE(?Tab:2)
                         END
                       END
                       BUTTON('&Close'),AT(118,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(171,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseCOUNTRY')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:COUNTRY.Open                                      ! File COUNTRY used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:COUNTRY,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,COU:INTEG_2)                          ! Add the sort order for COU:INTEG_2 for sort order 1
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort0:Locator.Init(,COU:COUNTRY,,BRW1)             ! Initialize the browse locator using  using key: COU:INTEG_2 , COU:COUNTRY
  BRW1.AddField(COU:COUNTRY,BRW1.Q.COU:COUNTRY)            ! Field COU:COUNTRY is a hot field or requires assignment from browse
  BRW1.AddField(COU:CURRENCY,BRW1.Q.COU:CURRENCY)          ! Field COU:CURRENCY is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('BrowseCOUNTRY',QuickWindow)                ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AskProcedure = 1
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:COUNTRY.Close
  END
  IF SELF.Opened
    INIMgr.Update('BrowseCOUNTRY',QuickWindow)             ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateCOUNTRY
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END
  SELF.ViewControl = ?View:2                               ! Setup the control used to initiate view only mode


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the CUSTOMER file
!!! </summary>
BrowseCUSTOMER PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(CUSTOMER)
                       PROJECT(CUS:CUST_NO)
                       PROJECT(CUS:CUSTOMER)
                       PROJECT(CUS:CONTACT_FIRST)
                       PROJECT(CUS:CONTACT_LAST)
                       PROJECT(CUS:PHONE_NO)
                       PROJECT(CUS:ADDRESS_LINE1)
                       PROJECT(CUS:ADDRESS_LINE2)
                       PROJECT(CUS:CITY)
                       PROJECT(CUS:STATE_PROVINCE)
                       PROJECT(CUS:COUNTRY)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
CUS:CUST_NO            LIKE(CUS:CUST_NO)              !List box control field - type derived from field
CUS:CUSTOMER           LIKE(CUS:CUSTOMER)             !List box control field - type derived from field
CUS:CONTACT_FIRST      LIKE(CUS:CONTACT_FIRST)        !List box control field - type derived from field
CUS:CONTACT_LAST       LIKE(CUS:CONTACT_LAST)         !List box control field - type derived from field
CUS:PHONE_NO           LIKE(CUS:PHONE_NO)             !List box control field - type derived from field
CUS:ADDRESS_LINE1      LIKE(CUS:ADDRESS_LINE1)        !List box control field - type derived from field
CUS:ADDRESS_LINE2      LIKE(CUS:ADDRESS_LINE2)        !List box control field - type derived from field
CUS:CITY               LIKE(CUS:CITY)                 !List box control field - type derived from field
CUS:STATE_PROVINCE     LIKE(CUS:STATE_PROVINCE)       !List box control field - type derived from field
CUS:COUNTRY            LIKE(CUS:COUNTRY)              !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the CUSTOMER file'),AT(,,358,198),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('BrowseCUSTOMER'),SYSTEM
                       LIST,AT(8,30,342,124),USE(?Browse:1),HVSCROLL,FORMAT('64R(2)|M~CUST NO~C(0)@n-14@80L(2)' & |
  '|M~CUSTOMER~L(2)@s25@64L(2)|M~CONTACT FIRST~L(2)@s15@80L(2)|M~CONTACT LAST~L(2)@s20@' & |
  '80L(2)|M~PHONE NO~L(2)@s20@80L(2)|M~ADDRESS LINE 1~L(2)@s30@80L(2)|M~ADDRESS LINE 2~' & |
  'L(2)@s30@80L(2)|M~CITY~L(2)@s25@64L(2)|M~STATE PROVINCE~L(2)@s15@'),FROM(Queue:Browse:1), |
  IMM,MSG('Browsing the CUSTOMER file')
                       BUTTON('&View'),AT(142,158,49,14),USE(?View:2),LEFT,ICON('WAVIEW.ICO'),FLAT,MSG('View Record'), |
  TIP('View Record')
                       BUTTON('&Insert'),AT(195,158,49,14),USE(?Insert:3),LEFT,ICON('WAINSERT.ICO'),FLAT,MSG('Insert a Record'), |
  TIP('Insert a Record')
                       BUTTON('&Change'),AT(248,158,49,14),USE(?Change:3),LEFT,ICON('WACHANGE.ICO'),DEFAULT,FLAT, |
  MSG('Change the Record'),TIP('Change the Record')
                       BUTTON('&Delete'),AT(301,158,49,14),USE(?Delete:3),LEFT,ICON('WADELETE.ICO'),FLAT,MSG('Delete the Record'), |
  TIP('Delete the Record')
                       SHEET,AT(4,4,350,172),USE(?CurrentTab)
                         TAB('&1) CUSTNAMEX'),USE(?Tab:2)
                         END
                         TAB('&2) CUSTREGION'),USE(?Tab:3)
                         END
                         TAB('&3) INTEG_61'),USE(?Tab:4)
                           BUTTON('Select COUNTRY'),AT(8,158,118,14),USE(?SelectCOUNTRY),LEFT,ICON('WAPARENT.ICO'),FLAT, |
  MSG('Select Parent Field'),TIP('Select Parent Field')
                         END
                         TAB('&4) INTEG_60'),USE(?Tab:5)
                         END
                       END
                       BUTTON('&Close'),AT(252,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(305,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort3:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 4
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseCUSTOMER')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('CUS:CUST_NO',CUS:CUST_NO)                          ! Added by: BrowseBox(ABC)
  BIND('CUS:CONTACT_FIRST',CUS:CONTACT_FIRST)              ! Added by: BrowseBox(ABC)
  BIND('CUS:CONTACT_LAST',CUS:CONTACT_LAST)                ! Added by: BrowseBox(ABC)
  BIND('CUS:PHONE_NO',CUS:PHONE_NO)                        ! Added by: BrowseBox(ABC)
  BIND('CUS:ADDRESS_LINE1',CUS:ADDRESS_LINE1)              ! Added by: BrowseBox(ABC)
  BIND('CUS:ADDRESS_LINE2',CUS:ADDRESS_LINE2)              ! Added by: BrowseBox(ABC)
  BIND('CUS:STATE_PROVINCE',CUS:STATE_PROVINCE)            ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:COUNTRY.Open                                      ! File COUNTRY used by this procedure, so make sure it's RelationManager is open
  Relate:CUSTOMER.Open                                     ! File CUSTOMER used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:CUSTOMER,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,CUS:CUSTREGION)                       ! Add the sort order for CUS:CUSTREGION for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,CUS:COUNTRY,,BRW1)             ! Initialize the browse locator using  using key: CUS:CUSTREGION , CUS:COUNTRY
  BRW1.AddSortOrder(,CUS:INTEG_61)                         ! Add the sort order for CUS:INTEG_61 for sort order 2
  BRW1.AddRange(CUS:COUNTRY,Relate:CUSTOMER,Relate:COUNTRY) ! Add file relationship range limit for sort order 2
  BRW1.AddSortOrder(,CUS:INTEG_60)                         ! Add the sort order for CUS:INTEG_60 for sort order 3
  BRW1.AddLocator(BRW1::Sort3:Locator)                     ! Browse has a locator for sort order 3
  BRW1::Sort3:Locator.Init(,CUS:CUST_NO,,BRW1)             ! Initialize the browse locator using  using key: CUS:INTEG_60 , CUS:CUST_NO
  BRW1.AddSortOrder(,CUS:CUSTNAMEX)                        ! Add the sort order for CUS:CUSTNAMEX for sort order 4
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 4
  BRW1::Sort0:Locator.Init(,CUS:CUSTOMER,,BRW1)            ! Initialize the browse locator using  using key: CUS:CUSTNAMEX , CUS:CUSTOMER
  BRW1.AddField(CUS:CUST_NO,BRW1.Q.CUS:CUST_NO)            ! Field CUS:CUST_NO is a hot field or requires assignment from browse
  BRW1.AddField(CUS:CUSTOMER,BRW1.Q.CUS:CUSTOMER)          ! Field CUS:CUSTOMER is a hot field or requires assignment from browse
  BRW1.AddField(CUS:CONTACT_FIRST,BRW1.Q.CUS:CONTACT_FIRST) ! Field CUS:CONTACT_FIRST is a hot field or requires assignment from browse
  BRW1.AddField(CUS:CONTACT_LAST,BRW1.Q.CUS:CONTACT_LAST)  ! Field CUS:CONTACT_LAST is a hot field or requires assignment from browse
  BRW1.AddField(CUS:PHONE_NO,BRW1.Q.CUS:PHONE_NO)          ! Field CUS:PHONE_NO is a hot field or requires assignment from browse
  BRW1.AddField(CUS:ADDRESS_LINE1,BRW1.Q.CUS:ADDRESS_LINE1) ! Field CUS:ADDRESS_LINE1 is a hot field or requires assignment from browse
  BRW1.AddField(CUS:ADDRESS_LINE2,BRW1.Q.CUS:ADDRESS_LINE2) ! Field CUS:ADDRESS_LINE2 is a hot field or requires assignment from browse
  BRW1.AddField(CUS:CITY,BRW1.Q.CUS:CITY)                  ! Field CUS:CITY is a hot field or requires assignment from browse
  BRW1.AddField(CUS:STATE_PROVINCE,BRW1.Q.CUS:STATE_PROVINCE) ! Field CUS:STATE_PROVINCE is a hot field or requires assignment from browse
  BRW1.AddField(CUS:COUNTRY,BRW1.Q.CUS:COUNTRY)            ! Field CUS:COUNTRY is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('BrowseCUSTOMER',QuickWindow)               ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AskProcedure = 1
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:COUNTRY.Close
    Relate:CUSTOMER.Close
  END
  IF SELF.Opened
    INIMgr.Update('BrowseCUSTOMER',QuickWindow)            ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateCUSTOMER
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?SelectCOUNTRY
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectCOUNTRY()
      ThisWindow.Reset
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END
  SELF.ViewControl = ?View:2                               ! Setup the control used to initiate view only mode


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSIF CHOICE(?CurrentTab) = 4
    RETURN SELF.SetSort(3,Force)
  ELSE
    RETURN SELF.SetSort(4,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the DEPARTMENT file
!!! </summary>
BrowseDEPARTMENT PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(DEPARTMENT)
                       PROJECT(DEP:DEPT_NO)
                       PROJECT(DEP:DEPARTMENT)
                       PROJECT(DEP:HEAD_DEPT)
                       PROJECT(DEP:MNGR_NO)
                       PROJECT(DEP:BUDGET)
                       PROJECT(DEP:LOCATION)
                       PROJECT(DEP:PHONE_NO)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
DEP:DEPT_NO            LIKE(DEP:DEPT_NO)              !List box control field - type derived from field
DEP:DEPARTMENT         LIKE(DEP:DEPARTMENT)           !List box control field - type derived from field
DEP:HEAD_DEPT          LIKE(DEP:HEAD_DEPT)            !List box control field - type derived from field
DEP:MNGR_NO            LIKE(DEP:MNGR_NO)              !List box control field - type derived from field
DEP:BUDGET             LIKE(DEP:BUDGET)               !List box control field - type derived from field
DEP:LOCATION           LIKE(DEP:LOCATION)             !List box control field - type derived from field
DEP:PHONE_NO           LIKE(DEP:PHONE_NO)             !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the DEPARTMENT file'),AT(,,358,198),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('BrowseDEPARTMENT'),SYSTEM
                       LIST,AT(8,30,342,124),USE(?Browse:1),HVSCROLL,FORMAT('32L(2)|M~DEPT NO~L(2)@s3@80L(2)|M' & |
  '~DEPARTMENT~L(2)@s25@40L(2)|M~HEAD DEPT~L(2)@s3@36R(2)|M~MNGR NO~C(0)@n-7@76D(32)|M~' & |
  'BUDGET~C(0)@n-17.2@64L(2)|M~LOCATION~L(2)@s15@80L(2)|M~PHONE NO~L(2)@s20@'),FROM(Queue:Browse:1), |
  IMM,MSG('Browsing the DEPARTMENT file')
                       BUTTON('&View'),AT(142,158,49,14),USE(?View:2),LEFT,ICON('WAVIEW.ICO'),FLAT,MSG('View Record'), |
  TIP('View Record')
                       BUTTON('&Insert'),AT(195,158,49,14),USE(?Insert:3),LEFT,ICON('WAINSERT.ICO'),FLAT,MSG('Insert a Record'), |
  TIP('Insert a Record')
                       BUTTON('&Change'),AT(248,158,49,14),USE(?Change:3),LEFT,ICON('WACHANGE.ICO'),DEFAULT,FLAT, |
  MSG('Change the Record'),TIP('Change the Record')
                       BUTTON('&Delete'),AT(301,158,49,14),USE(?Delete:3),LEFT,ICON('WADELETE.ICO'),FLAT,MSG('Delete the Record'), |
  TIP('Delete the Record')
                       SHEET,AT(4,4,350,172),USE(?CurrentTab)
                         TAB('&1) BUDGETX'),USE(?Tab:2)
                         END
                         TAB('&2) INTEG_31'),USE(?Tab:3)
                           BUTTON('Select EMPLOYEE'),AT(8,158,118,14),USE(?SelectEMPLOYEE),LEFT,ICON('WAPARENT.ICO'), |
  FLAT,MSG('Select Parent Field'),TIP('Select Parent Field')
                         END
                         TAB('&3) INTEG_17'),USE(?Tab:4)
                           BUTTON('Select DEPARTMENT2'),AT(8,158,118,14),USE(?SelectDEPARTMENT2),LEFT,ICON('WAPARENT.ICO'), |
  FLAT,MSG('Select Parent Field'),TIP('Select Parent Field')
                         END
                         TAB('&4) INTEG_16'),USE(?Tab:5)
                         END
                         TAB('&5) RDB_4'),USE(?Tab:6)
                         END
                       END
                       BUTTON('&Close'),AT(252,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(305,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort3:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 4
BRW1::Sort4:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 5
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseDEPARTMENT')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('DEP:DEPT_NO',DEP:DEPT_NO)                          ! Added by: BrowseBox(ABC)
  BIND('DEP:HEAD_DEPT',DEP:HEAD_DEPT)                      ! Added by: BrowseBox(ABC)
  BIND('DEP:MNGR_NO',DEP:MNGR_NO)                          ! Added by: BrowseBox(ABC)
  BIND('DEP:PHONE_NO',DEP:PHONE_NO)                        ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:DEPARTMENT.Open                                   ! File DEPARTMENT used by this procedure, so make sure it's RelationManager is open
  Relate:DEPARTMENT2.Open                                  ! File DEPARTMENT2 used by this procedure, so make sure it's RelationManager is open
  Relate:EMPLOYEE.Open                                     ! File EMPLOYEE used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:DEPARTMENT,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,DEP:INTEG_31)                         ! Add the sort order for DEP:INTEG_31 for sort order 1
  BRW1.AddRange(DEP:MNGR_NO,Relate:DEPARTMENT,Relate:EMPLOYEE) ! Add file relationship range limit for sort order 1
  BRW1.AddSortOrder(,DEP:INTEG_17)                         ! Add the sort order for DEP:INTEG_17 for sort order 2
  BRW1.AddRange(DEP:HEAD_DEPT,Relate:DEPARTMENT,Relate:DEPARTMENT2) ! Add file relationship range limit for sort order 2
  BRW1.AddSortOrder(,DEP:INTEG_16)                         ! Add the sort order for DEP:INTEG_16 for sort order 3
  BRW1.AddLocator(BRW1::Sort3:Locator)                     ! Browse has a locator for sort order 3
  BRW1::Sort3:Locator.Init(,DEP:DEPT_NO,,BRW1)             ! Initialize the browse locator using  using key: DEP:INTEG_16 , DEP:DEPT_NO
  BRW1.AddSortOrder(,DEP:RDB_4)                            ! Add the sort order for DEP:RDB_4 for sort order 4
  BRW1.AddLocator(BRW1::Sort4:Locator)                     ! Browse has a locator for sort order 4
  BRW1::Sort4:Locator.Init(,DEP:DEPARTMENT,,BRW1)          ! Initialize the browse locator using  using key: DEP:RDB_4 , DEP:DEPARTMENT
  BRW1.AddSortOrder(,DEP:BUDGETX)                          ! Add the sort order for DEP:BUDGETX for sort order 5
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 5
  BRW1::Sort0:Locator.Init(,DEP:BUDGET,,BRW1)              ! Initialize the browse locator using  using key: DEP:BUDGETX , DEP:BUDGET
  BRW1.AddField(DEP:DEPT_NO,BRW1.Q.DEP:DEPT_NO)            ! Field DEP:DEPT_NO is a hot field or requires assignment from browse
  BRW1.AddField(DEP:DEPARTMENT,BRW1.Q.DEP:DEPARTMENT)      ! Field DEP:DEPARTMENT is a hot field or requires assignment from browse
  BRW1.AddField(DEP:HEAD_DEPT,BRW1.Q.DEP:HEAD_DEPT)        ! Field DEP:HEAD_DEPT is a hot field or requires assignment from browse
  BRW1.AddField(DEP:MNGR_NO,BRW1.Q.DEP:MNGR_NO)            ! Field DEP:MNGR_NO is a hot field or requires assignment from browse
  BRW1.AddField(DEP:BUDGET,BRW1.Q.DEP:BUDGET)              ! Field DEP:BUDGET is a hot field or requires assignment from browse
  BRW1.AddField(DEP:LOCATION,BRW1.Q.DEP:LOCATION)          ! Field DEP:LOCATION is a hot field or requires assignment from browse
  BRW1.AddField(DEP:PHONE_NO,BRW1.Q.DEP:PHONE_NO)          ! Field DEP:PHONE_NO is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('BrowseDEPARTMENT',QuickWindow)             ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AskProcedure = 1
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:DEPARTMENT.Close
    Relate:DEPARTMENT2.Close
    Relate:EMPLOYEE.Close
  END
  IF SELF.Opened
    INIMgr.Update('BrowseDEPARTMENT',QuickWindow)          ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateDEPARTMENT
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?SelectEMPLOYEE
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectEMPLOYEE()
      ThisWindow.Reset
    OF ?SelectDEPARTMENT2
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectDEPARTMENT2()
      ThisWindow.Reset
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END
  SELF.ViewControl = ?View:2                               ! Setup the control used to initiate view only mode


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSIF CHOICE(?CurrentTab) = 4
    RETURN SELF.SetSort(3,Force)
  ELSIF CHOICE(?CurrentTab) = 5
    RETURN SELF.SetSort(4,Force)
  ELSE
    RETURN SELF.SetSort(5,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the EMPLOYEE file
!!! </summary>
BrowseEMPLOYEE PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(EMPLOYEE)
                       PROJECT(EMP:EMP_NO)
                       PROJECT(EMP:FIRST_NAME)
                       PROJECT(EMP:LAST_NAME)
                       PROJECT(EMP:PHONE_EXT)
                       PROJECT(EMP:HIRE_DATE_DATE)
                       PROJECT(EMP:HIRE_DATE_TIME)
                       PROJECT(EMP:DEPT_NO)
                       PROJECT(EMP:JOB_CODE)
                       PROJECT(EMP:JOB_GRADE)
                       PROJECT(EMP:JOB_COUNTRY)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
EMP:EMP_NO             LIKE(EMP:EMP_NO)               !List box control field - type derived from field
EMP:FIRST_NAME         LIKE(EMP:FIRST_NAME)           !List box control field - type derived from field
EMP:LAST_NAME          LIKE(EMP:LAST_NAME)            !List box control field - type derived from field
EMP:PHONE_EXT          LIKE(EMP:PHONE_EXT)            !List box control field - type derived from field
EMP:HIRE_DATE_DATE     LIKE(EMP:HIRE_DATE_DATE)       !List box control field - type derived from field
EMP:HIRE_DATE_TIME     LIKE(EMP:HIRE_DATE_TIME)       !List box control field - type derived from field
EMP:DEPT_NO            LIKE(EMP:DEPT_NO)              !List box control field - type derived from field
EMP:JOB_CODE           LIKE(EMP:JOB_CODE)             !List box control field - type derived from field
EMP:JOB_GRADE          LIKE(EMP:JOB_GRADE)            !List box control field - type derived from field
EMP:JOB_COUNTRY        LIKE(EMP:JOB_COUNTRY)          !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the EMPLOYEE file'),AT(,,358,216),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('BrowseEMPLOYEE'),SYSTEM
                       LIST,AT(8,30,342,124),USE(?Browse:1),HVSCROLL,FORMAT('36R(2)|M~EMP NO~C(0)@n-7@64L(2)|M' & |
  '~FIRST NAME~L(2)@s15@80L(2)|M~LAST NAME~L(2)@s20@40L(2)|M~PHONE EXT~L(2)@s4@80R(2)|M' & |
  '~HIRE DATE DATE~C(0)@d17@80R(2)|M~HIRE DATE TIME~C(0)@t7@32L(2)|M~DEPT NO~L(2)@s3@36' & |
  'L(2)|M~JOB CODE~L(2)@s5@40R(2)|M~JOB GRADE~C(0)@n-7@'),FROM(Queue:Browse:1),IMM,MSG('Browsing t' & |
  'he EMPLOYEE file')
                       BUTTON('&View'),AT(142,158,49,14),USE(?View:2),LEFT,ICON('WAVIEW.ICO'),FLAT,MSG('View Record'), |
  TIP('View Record')
                       BUTTON('&Insert'),AT(195,158,49,14),USE(?Insert:3),LEFT,ICON('WAINSERT.ICO'),FLAT,MSG('Insert a Record'), |
  TIP('Insert a Record')
                       BUTTON('&Change'),AT(248,158,49,14),USE(?Change:3),LEFT,ICON('WACHANGE.ICO'),DEFAULT,FLAT, |
  MSG('Change the Record'),TIP('Change the Record')
                       BUTTON('&Delete'),AT(301,158,49,14),USE(?Delete:3),LEFT,ICON('WADELETE.ICO'),FLAT,MSG('Delete the Record'), |
  TIP('Delete the Record')
                       SHEET,AT(4,4,350,172),USE(?CurrentTab)
                         TAB('&1) NAMEX'),USE(?Tab:2)
                         END
                         TAB('&2) INTEG_28'),USE(?Tab:3)
                           BUTTON('Select DEPARTMENT'),AT(8,158,118,14),USE(?SelectDEPARTMENT),LEFT,ICON('WAPARENT.ICO'), |
  FLAT,MSG('Select Parent Field'),TIP('Select Parent Field')
                         END
                         TAB('&3) INTEG_29'),USE(?Tab:4)
                           BUTTON('Select JOB'),AT(8,158,118,14),USE(?SelectJOB),LEFT,ICON('WAPARENT.ICO'),FLAT,MSG('Select Parent Field'), |
  TIP('Select Parent Field')
                         END
                         TAB('&4) INTEG_27'),USE(?Tab:5)
                         END
                       END
                       BUTTON('&Close'),AT(252,198,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(305,198,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort3:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 4
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseEMPLOYEE')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('EMP:EMP_NO',EMP:EMP_NO)                            ! Added by: BrowseBox(ABC)
  BIND('EMP:FIRST_NAME',EMP:FIRST_NAME)                    ! Added by: BrowseBox(ABC)
  BIND('EMP:LAST_NAME',EMP:LAST_NAME)                      ! Added by: BrowseBox(ABC)
  BIND('EMP:PHONE_EXT',EMP:PHONE_EXT)                      ! Added by: BrowseBox(ABC)
  BIND('EMP:DEPT_NO',EMP:DEPT_NO)                          ! Added by: BrowseBox(ABC)
  BIND('EMP:JOB_CODE',EMP:JOB_CODE)                        ! Added by: BrowseBox(ABC)
  BIND('EMP:JOB_GRADE',EMP:JOB_GRADE)                      ! Added by: BrowseBox(ABC)
  BIND('EMP:JOB_COUNTRY',EMP:JOB_COUNTRY)                  ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:DEPARTMENT.Open                                   ! File DEPARTMENT used by this procedure, so make sure it's RelationManager is open
  Relate:EMPLOYEE.Open                                     ! File EMPLOYEE used by this procedure, so make sure it's RelationManager is open
  Relate:JOB.Open                                          ! File JOB used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:EMPLOYEE,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,EMP:INTEG_28)                         ! Add the sort order for EMP:INTEG_28 for sort order 1
  BRW1.AddRange(EMP:DEPT_NO,Relate:EMPLOYEE,Relate:DEPARTMENT) ! Add file relationship range limit for sort order 1
  BRW1.AddSortOrder(,EMP:INTEG_29)                         ! Add the sort order for EMP:INTEG_29 for sort order 2
  BRW1.AddRange(EMP:JOB_COUNTRY,Relate:EMPLOYEE,Relate:JOB) ! Add file relationship range limit for sort order 2
  BRW1.AddSortOrder(,EMP:INTEG_27)                         ! Add the sort order for EMP:INTEG_27 for sort order 3
  BRW1.AddLocator(BRW1::Sort3:Locator)                     ! Browse has a locator for sort order 3
  BRW1::Sort3:Locator.Init(,EMP:EMP_NO,,BRW1)              ! Initialize the browse locator using  using key: EMP:INTEG_27 , EMP:EMP_NO
  BRW1.AddSortOrder(,EMP:NAMEX)                            ! Add the sort order for EMP:NAMEX for sort order 4
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 4
  BRW1::Sort0:Locator.Init(,EMP:LAST_NAME,,BRW1)           ! Initialize the browse locator using  using key: EMP:NAMEX , EMP:LAST_NAME
  BRW1.AddField(EMP:EMP_NO,BRW1.Q.EMP:EMP_NO)              ! Field EMP:EMP_NO is a hot field or requires assignment from browse
  BRW1.AddField(EMP:FIRST_NAME,BRW1.Q.EMP:FIRST_NAME)      ! Field EMP:FIRST_NAME is a hot field or requires assignment from browse
  BRW1.AddField(EMP:LAST_NAME,BRW1.Q.EMP:LAST_NAME)        ! Field EMP:LAST_NAME is a hot field or requires assignment from browse
  BRW1.AddField(EMP:PHONE_EXT,BRW1.Q.EMP:PHONE_EXT)        ! Field EMP:PHONE_EXT is a hot field or requires assignment from browse
  BRW1.AddField(EMP:HIRE_DATE_DATE,BRW1.Q.EMP:HIRE_DATE_DATE) ! Field EMP:HIRE_DATE_DATE is a hot field or requires assignment from browse
  BRW1.AddField(EMP:HIRE_DATE_TIME,BRW1.Q.EMP:HIRE_DATE_TIME) ! Field EMP:HIRE_DATE_TIME is a hot field or requires assignment from browse
  BRW1.AddField(EMP:DEPT_NO,BRW1.Q.EMP:DEPT_NO)            ! Field EMP:DEPT_NO is a hot field or requires assignment from browse
  BRW1.AddField(EMP:JOB_CODE,BRW1.Q.EMP:JOB_CODE)          ! Field EMP:JOB_CODE is a hot field or requires assignment from browse
  BRW1.AddField(EMP:JOB_GRADE,BRW1.Q.EMP:JOB_GRADE)        ! Field EMP:JOB_GRADE is a hot field or requires assignment from browse
  BRW1.AddField(EMP:JOB_COUNTRY,BRW1.Q.EMP:JOB_COUNTRY)    ! Field EMP:JOB_COUNTRY is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('BrowseEMPLOYEE',QuickWindow)               ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AskProcedure = 1
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:DEPARTMENT.Close
    Relate:EMPLOYEE.Close
    Relate:JOB.Close
  END
  IF SELF.Opened
    INIMgr.Update('BrowseEMPLOYEE',QuickWindow)            ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateEMPLOYEE
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?SelectDEPARTMENT
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectDEPARTMENT()
      ThisWindow.Reset
    OF ?SelectJOB
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectJOB()
      ThisWindow.Reset
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END
  SELF.ViewControl = ?View:2                               ! Setup the control used to initiate view only mode


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSIF CHOICE(?CurrentTab) = 4
    RETURN SELF.SetSort(3,Force)
  ELSE
    RETURN SELF.SetSort(4,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the EMPLOYEE_PROJECT file
!!! </summary>
BrowseEMPLOYEE_PROJECT PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(EMPLOYEE_PROJECT)
                       PROJECT(EMP2:EMP_NO)
                       PROJECT(EMP2:PROJ_ID)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
EMP2:EMP_NO            LIKE(EMP2:EMP_NO)              !List box control field - type derived from field
EMP2:PROJ_ID           LIKE(EMP2:PROJ_ID)             !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the EMPLOYEE_PROJECT file'),AT(,,277,198),FONT('MS Sans Serif',8,,FONT:regular, |
  CHARSET:DEFAULT),RESIZE,CENTER,GRAY,IMM,MDI,HLP('BrowseEMPLOYEE_PROJECT'),SYSTEM
                       LIST,AT(8,30,261,124),USE(?Browse:1),HVSCROLL,FORMAT('36R(2)|M~EMP NO~C(0)@n-7@32L(2)|M' & |
  '~PROJ ID~L(2)@s5@'),FROM(Queue:Browse:1),IMM,MSG('Browsing the EMPLOYEE_PROJECT file')
                       BUTTON('&View'),AT(61,158,49,14),USE(?View:2),LEFT,ICON('WAVIEW.ICO'),FLAT,MSG('View Record'), |
  TIP('View Record')
                       BUTTON('&Insert'),AT(114,158,49,14),USE(?Insert:3),LEFT,ICON('WAINSERT.ICO'),FLAT,MSG('Insert a Record'), |
  TIP('Insert a Record')
                       BUTTON('&Change'),AT(167,158,49,14),USE(?Change:3),LEFT,ICON('WACHANGE.ICO'),DEFAULT,FLAT, |
  MSG('Change the Record'),TIP('Change the Record')
                       BUTTON('&Delete'),AT(220,158,49,14),USE(?Delete:3),LEFT,ICON('WADELETE.ICO'),FLAT,MSG('Delete the Record'), |
  TIP('Delete the Record')
                       SHEET,AT(4,4,269,172),USE(?CurrentTab)
                         TAB('&1) INTEG_40'),USE(?Tab:2)
                           BUTTON('Select EMPLOYEE'),AT(8,158,49,14),USE(?SelectEMPLOYEE),LEFT,ICON('WAPARENT.ICO'),FLAT, |
  MSG('Select Parent Field'),TIP('Select Parent Field')
                         END
                         TAB('&2) INTEG_41'),USE(?Tab:3)
                           BUTTON('Select PROJECT'),AT(8,158,49,14),USE(?SelectPROJECT),LEFT,ICON('WAPARENT.ICO'),FLAT, |
  MSG('Select Parent Field'),TIP('Select Parent Field')
                         END
                         TAB('&3) INTEG_39'),USE(?Tab:4)
                         END
                       END
                       BUTTON('&Close'),AT(171,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(224,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort2:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 3
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseEMPLOYEE_PROJECT')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('EMP2:EMP_NO',EMP2:EMP_NO)                          ! Added by: BrowseBox(ABC)
  BIND('EMP2:PROJ_ID',EMP2:PROJ_ID)                        ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:EMPLOYEE.Open                                     ! File EMPLOYEE used by this procedure, so make sure it's RelationManager is open
  Relate:EMPLOYEE_PROJECT.Open                             ! File EMPLOYEE_PROJECT used by this procedure, so make sure it's RelationManager is open
  Relate:PROJECT.Open                                      ! File PROJECT used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:EMPLOYEE_PROJECT,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,EMP2:INTEG_41)                        ! Add the sort order for EMP2:INTEG_41 for sort order 1
  BRW1.AddRange(EMP2:PROJ_ID,Relate:EMPLOYEE_PROJECT,Relate:PROJECT) ! Add file relationship range limit for sort order 1
  BRW1.AddSortOrder(,EMP2:INTEG_39)                        ! Add the sort order for EMP2:INTEG_39 for sort order 2
  BRW1.AddLocator(BRW1::Sort2:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort2:Locator.Init(,EMP2:EMP_NO,,BRW1)             ! Initialize the browse locator using  using key: EMP2:INTEG_39 , EMP2:EMP_NO
  BRW1.AddSortOrder(,EMP2:INTEG_40)                        ! Add the sort order for EMP2:INTEG_40 for sort order 3
  BRW1.AddRange(EMP2:EMP_NO,Relate:EMPLOYEE_PROJECT,Relate:EMPLOYEE) ! Add file relationship range limit for sort order 3
  BRW1.AddField(EMP2:EMP_NO,BRW1.Q.EMP2:EMP_NO)            ! Field EMP2:EMP_NO is a hot field or requires assignment from browse
  BRW1.AddField(EMP2:PROJ_ID,BRW1.Q.EMP2:PROJ_ID)          ! Field EMP2:PROJ_ID is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('BrowseEMPLOYEE_PROJECT',QuickWindow)       ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AskProcedure = 1
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:EMPLOYEE.Close
    Relate:EMPLOYEE_PROJECT.Close
    Relate:PROJECT.Close
  END
  IF SELF.Opened
    INIMgr.Update('BrowseEMPLOYEE_PROJECT',QuickWindow)    ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateEMPLOYEE_PROJECT
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?SelectEMPLOYEE
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectEMPLOYEE()
      ThisWindow.Reset
    OF ?SelectPROJECT
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectPROJECT()
      ThisWindow.Reset
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END
  SELF.ViewControl = ?View:2                               ! Setup the control used to initiate view only mode


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSE
    RETURN SELF.SetSort(3,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the JOB file
!!! </summary>
BrowseJOB PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(JOB)
                       PROJECT(JOB:JOB_CODE)
                       PROJECT(JOB:JOB_GRADE)
                       PROJECT(JOB:JOB_COUNTRY)
                       PROJECT(JOB:JOB_TITLE)
                       PROJECT(JOB:MIN_SALARY)
                       PROJECT(JOB:MAX_SALARY)
                       PROJECT(JOB:LANGUAGE_REQ)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
JOB:JOB_CODE           LIKE(JOB:JOB_CODE)             !List box control field - type derived from field
JOB:JOB_GRADE          LIKE(JOB:JOB_GRADE)            !List box control field - type derived from field
JOB:JOB_COUNTRY        LIKE(JOB:JOB_COUNTRY)          !List box control field - type derived from field
JOB:JOB_TITLE          LIKE(JOB:JOB_TITLE)            !List box control field - type derived from field
JOB:MIN_SALARY         LIKE(JOB:MIN_SALARY)           !List box control field - type derived from field
JOB:MAX_SALARY         LIKE(JOB:MAX_SALARY)           !List box control field - type derived from field
JOB:LANGUAGE_REQ       LIKE(JOB:LANGUAGE_REQ)         !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the JOB file'),AT(,,358,198),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('BrowseJOB'),SYSTEM
                       LIST,AT(8,30,342,124),USE(?Browse:1),HVSCROLL,FORMAT('36L(2)|M~JOB CODE~L(2)@s5@40R(2)|' & |
  'M~JOB GRADE~C(0)@n-7@64L(2)|M~JOB COUNTRY~L(2)@s15@80L(2)|M~JOB TITLE~L(2)@s25@64D(1' & |
  '8)|M~MIN SALARY~C(0)@n-14.2@64D(18)|M~MAX SALARY~C(0)@n-14.2@80L(2)|M~LANGUAGE REQ~L(2)@s91@'), |
  FROM(Queue:Browse:1),IMM,MSG('Browsing the JOB file')
                       BUTTON('&View'),AT(142,158,49,14),USE(?View:2),LEFT,ICON('WAVIEW.ICO'),FLAT,MSG('View Record'), |
  TIP('View Record')
                       BUTTON('&Insert'),AT(195,158,49,14),USE(?Insert:3),LEFT,ICON('WAINSERT.ICO'),FLAT,MSG('Insert a Record'), |
  TIP('Insert a Record')
                       BUTTON('&Change'),AT(248,158,49,14),USE(?Change:3),LEFT,ICON('WACHANGE.ICO'),DEFAULT,FLAT, |
  MSG('Change the Record'),TIP('Change the Record')
                       BUTTON('&Delete'),AT(301,158,49,14),USE(?Delete:3),LEFT,ICON('WADELETE.ICO'),FLAT,MSG('Delete the Record'), |
  TIP('Delete the Record')
                       SHEET,AT(4,4,350,172),USE(?CurrentTab)
                         TAB('&1) MAXSALX'),USE(?Tab:2)
                         END
                         TAB('&2) MINSALX'),USE(?Tab:3)
                         END
                         TAB('&3) INTEG_11'),USE(?Tab:4)
                           BUTTON('Select COUNTRY'),AT(8,158,118,14),USE(?SelectCOUNTRY),LEFT,ICON('WAPARENT.ICO'),FLAT, |
  MSG('Select Parent Field'),TIP('Select Parent Field')
                         END
                         TAB('&4) INTEG_10'),USE(?Tab:5)
                         END
                       END
                       BUTTON('&Close'),AT(252,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(305,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort3:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 4
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseJOB')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('JOB:JOB_CODE',JOB:JOB_CODE)                        ! Added by: BrowseBox(ABC)
  BIND('JOB:JOB_GRADE',JOB:JOB_GRADE)                      ! Added by: BrowseBox(ABC)
  BIND('JOB:JOB_COUNTRY',JOB:JOB_COUNTRY)                  ! Added by: BrowseBox(ABC)
  BIND('JOB:JOB_TITLE',JOB:JOB_TITLE)                      ! Added by: BrowseBox(ABC)
  BIND('JOB:MIN_SALARY',JOB:MIN_SALARY)                    ! Added by: BrowseBox(ABC)
  BIND('JOB:MAX_SALARY',JOB:MAX_SALARY)                    ! Added by: BrowseBox(ABC)
  BIND('JOB:LANGUAGE_REQ',JOB:LANGUAGE_REQ)                ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:COUNTRY.Open                                      ! File COUNTRY used by this procedure, so make sure it's RelationManager is open
  Relate:JOB.Open                                          ! File JOB used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:JOB,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,JOB:MINSALX)                          ! Add the sort order for JOB:MINSALX for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,JOB:JOB_COUNTRY,,BRW1)         ! Initialize the browse locator using  using key: JOB:MINSALX , JOB:JOB_COUNTRY
  BRW1.AddSortOrder(,JOB:INTEG_11)                         ! Add the sort order for JOB:INTEG_11 for sort order 2
  BRW1.AddRange(JOB:JOB_COUNTRY,Relate:JOB,Relate:COUNTRY) ! Add file relationship range limit for sort order 2
  BRW1.AddSortOrder(,JOB:INTEG_10)                         ! Add the sort order for JOB:INTEG_10 for sort order 3
  BRW1.AddLocator(BRW1::Sort3:Locator)                     ! Browse has a locator for sort order 3
  BRW1::Sort3:Locator.Init(,JOB:JOB_CODE,,BRW1)            ! Initialize the browse locator using  using key: JOB:INTEG_10 , JOB:JOB_CODE
  BRW1.AddSortOrder(,JOB:MAXSALX)                          ! Add the sort order for JOB:MAXSALX for sort order 4
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 4
  BRW1::Sort0:Locator.Init(,JOB:JOB_COUNTRY,,BRW1)         ! Initialize the browse locator using  using key: JOB:MAXSALX , JOB:JOB_COUNTRY
  BRW1.AddField(JOB:JOB_CODE,BRW1.Q.JOB:JOB_CODE)          ! Field JOB:JOB_CODE is a hot field or requires assignment from browse
  BRW1.AddField(JOB:JOB_GRADE,BRW1.Q.JOB:JOB_GRADE)        ! Field JOB:JOB_GRADE is a hot field or requires assignment from browse
  BRW1.AddField(JOB:JOB_COUNTRY,BRW1.Q.JOB:JOB_COUNTRY)    ! Field JOB:JOB_COUNTRY is a hot field or requires assignment from browse
  BRW1.AddField(JOB:JOB_TITLE,BRW1.Q.JOB:JOB_TITLE)        ! Field JOB:JOB_TITLE is a hot field or requires assignment from browse
  BRW1.AddField(JOB:MIN_SALARY,BRW1.Q.JOB:MIN_SALARY)      ! Field JOB:MIN_SALARY is a hot field or requires assignment from browse
  BRW1.AddField(JOB:MAX_SALARY,BRW1.Q.JOB:MAX_SALARY)      ! Field JOB:MAX_SALARY is a hot field or requires assignment from browse
  BRW1.AddField(JOB:LANGUAGE_REQ,BRW1.Q.JOB:LANGUAGE_REQ)  ! Field JOB:LANGUAGE_REQ is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('BrowseJOB',QuickWindow)                    ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AskProcedure = 1
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:COUNTRY.Close
    Relate:JOB.Close
  END
  IF SELF.Opened
    INIMgr.Update('BrowseJOB',QuickWindow)                 ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateJOB
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?SelectCOUNTRY
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectCOUNTRY()
      ThisWindow.Reset
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END
  SELF.ViewControl = ?View:2                               ! Setup the control used to initiate view only mode


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSIF CHOICE(?CurrentTab) = 4
    RETURN SELF.SetSort(3,Force)
  ELSE
    RETURN SELF.SetSort(4,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the PHONE_LIST file
!!! </summary>
BrowsePHONE_LIST PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(PHONE_LIST)
                       PROJECT(PHO:EMP_NO)
                       PROJECT(PHO:FIRST_NAME)
                       PROJECT(PHO:LAST_NAME)
                       PROJECT(PHO:PHONE_EXT)
                       PROJECT(PHO:LOCATION)
                       PROJECT(PHO:PHONE_NO)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
PHO:EMP_NO             LIKE(PHO:EMP_NO)               !List box control field - type derived from field
PHO:FIRST_NAME         LIKE(PHO:FIRST_NAME)           !List box control field - type derived from field
PHO:LAST_NAME          LIKE(PHO:LAST_NAME)            !List box control field - type derived from field
PHO:PHONE_EXT          LIKE(PHO:PHONE_EXT)            !List box control field - type derived from field
PHO:LOCATION           LIKE(PHO:LOCATION)             !List box control field - type derived from field
PHO:PHONE_NO           LIKE(PHO:PHONE_NO)             !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the PHONE_LIST file'),AT(,,358,198),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('BrowsePHONE_LIST'),SYSTEM
                       LIST,AT(8,30,342,124),USE(?Browse:1),HVSCROLL,FORMAT('36R(2)|M~EMP NO~C(0)@n-7@64L(2)|M' & |
  '~FIRST NAME~L(2)@s15@80L(2)|M~LAST NAME~L(2)@s20@40L(2)|M~PHONE EXT~L(2)@s4@64L(2)|M' & |
  '~LOCATION~L(2)@s15@80L(2)|M~PHONE NO~L(2)@s20@'),FROM(Queue:Browse:1),IMM,MSG('Browsing t' & |
  'he PHONE_LIST file')
                       BUTTON('&View'),AT(142,158,49,14),USE(?View:2),LEFT,ICON('WAVIEW.ICO'),FLAT,MSG('View Record'), |
  TIP('View Record')
                       BUTTON('&Insert'),AT(195,158,49,14),USE(?Insert:3),LEFT,ICON('WAINSERT.ICO'),FLAT,MSG('Insert a Record'), |
  TIP('Insert a Record')
                       BUTTON('&Change'),AT(248,158,49,14),USE(?Change:3),LEFT,ICON('WACHANGE.ICO'),DEFAULT,FLAT, |
  MSG('Change the Record'),TIP('Change the Record')
                       BUTTON('&Delete'),AT(301,158,49,14),USE(?Delete:3),LEFT,ICON('WADELETE.ICO'),FLAT,MSG('Delete the Record'), |
  TIP('Delete the Record')
                       SHEET,AT(4,4,350,172),USE(?CurrentTab)
                         TAB('&1) Record Order'),USE(?Tab:2)
                         END
                       END
                       BUTTON('&Close'),AT(252,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(305,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowsePHONE_LIST')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('PHO:EMP_NO',PHO:EMP_NO)                            ! Added by: BrowseBox(ABC)
  BIND('PHO:FIRST_NAME',PHO:FIRST_NAME)                    ! Added by: BrowseBox(ABC)
  BIND('PHO:LAST_NAME',PHO:LAST_NAME)                      ! Added by: BrowseBox(ABC)
  BIND('PHO:PHONE_EXT',PHO:PHONE_EXT)                      ! Added by: BrowseBox(ABC)
  BIND('PHO:PHONE_NO',PHO:PHONE_NO)                        ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:PHONE_LIST.Open                                   ! File PHONE_LIST used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:PHONE_LIST,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,)                                     ! Add the sort order for  for sort order 1
  BRW1.AddField(PHO:EMP_NO,BRW1.Q.PHO:EMP_NO)              ! Field PHO:EMP_NO is a hot field or requires assignment from browse
  BRW1.AddField(PHO:FIRST_NAME,BRW1.Q.PHO:FIRST_NAME)      ! Field PHO:FIRST_NAME is a hot field or requires assignment from browse
  BRW1.AddField(PHO:LAST_NAME,BRW1.Q.PHO:LAST_NAME)        ! Field PHO:LAST_NAME is a hot field or requires assignment from browse
  BRW1.AddField(PHO:PHONE_EXT,BRW1.Q.PHO:PHONE_EXT)        ! Field PHO:PHONE_EXT is a hot field or requires assignment from browse
  BRW1.AddField(PHO:LOCATION,BRW1.Q.PHO:LOCATION)          ! Field PHO:LOCATION is a hot field or requires assignment from browse
  BRW1.AddField(PHO:PHONE_NO,BRW1.Q.PHO:PHONE_NO)          ! Field PHO:PHONE_NO is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('BrowsePHONE_LIST',QuickWindow)             ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AskProcedure = 1
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:PHONE_LIST.Close
  END
  IF SELF.Opened
    INIMgr.Update('BrowsePHONE_LIST',QuickWindow)          ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdatePHONE_LIST
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END
  SELF.ViewControl = ?View:2                               ! Setup the control used to initiate view only mode


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the PROJECT file
!!! </summary>
BrowsePROJECT PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(PROJECT)
                       PROJECT(PRO:PROJ_ID)
                       PROJECT(PRO:PROJ_NAME)
                       PROJECT(PRO:TEAM_LEADER)
                       PROJECT(PRO:PRODUCT)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
PRO:PROJ_ID            LIKE(PRO:PROJ_ID)              !List box control field - type derived from field
PRO:PROJ_NAME          LIKE(PRO:PROJ_NAME)            !List box control field - type derived from field
PRO:TEAM_LEADER        LIKE(PRO:TEAM_LEADER)          !List box control field - type derived from field
PRO:PRODUCT            LIKE(PRO:PRODUCT)              !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the PROJECT file'),AT(,,277,198),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('BrowsePROJECT'),SYSTEM
                       LIST,AT(8,30,261,124),USE(?Browse:1),HVSCROLL,FORMAT('32L(2)|M~PROJ ID~L(2)@s5@80L(2)|M' & |
  '~PROJ NAME~L(2)@s20@48R(2)|M~TEAM LEADER~C(0)@n-7@52L(2)|M~PRODUCT~L(2)@s12@'),FROM(Queue:Browse:1), |
  IMM,MSG('Browsing the PROJECT file')
                       BUTTON('&View'),AT(61,158,49,14),USE(?View:2),LEFT,ICON('WAVIEW.ICO'),FLAT,MSG('View Record'), |
  TIP('View Record')
                       BUTTON('&Insert'),AT(114,158,49,14),USE(?Insert:3),LEFT,ICON('WAINSERT.ICO'),FLAT,MSG('Insert a Record'), |
  TIP('Insert a Record')
                       BUTTON('&Change'),AT(167,158,49,14),USE(?Change:3),LEFT,ICON('WACHANGE.ICO'),DEFAULT,FLAT, |
  MSG('Change the Record'),TIP('Change the Record')
                       BUTTON('&Delete'),AT(220,158,49,14),USE(?Delete:3),LEFT,ICON('WADELETE.ICO'),FLAT,MSG('Delete the Record'), |
  TIP('Delete the Record')
                       SHEET,AT(4,4,269,172),USE(?CurrentTab)
                         TAB('&1) INTEG_36'),USE(?Tab:2)
                           BUTTON('Select EMPLOYEE'),AT(8,158,49,14),USE(?SelectEMPLOYEE),LEFT,ICON('WAPARENT.ICO'),FLAT, |
  MSG('Select Parent Field'),TIP('Select Parent Field')
                         END
                         TAB('&2) PRODTYPEX'),USE(?Tab:3)
                         END
                         TAB('&3) INTEG_35'),USE(?Tab:4)
                         END
                         TAB('&4) RDB_11'),USE(?Tab:5)
                         END
                       END
                       BUTTON('&Close'),AT(171,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(224,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort2:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 3
BRW1::Sort3:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 4
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowsePROJECT')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('PRO:PROJ_ID',PRO:PROJ_ID)                          ! Added by: BrowseBox(ABC)
  BIND('PRO:PROJ_NAME',PRO:PROJ_NAME)                      ! Added by: BrowseBox(ABC)
  BIND('PRO:TEAM_LEADER',PRO:TEAM_LEADER)                  ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:EMPLOYEE.Open                                     ! File EMPLOYEE used by this procedure, so make sure it's RelationManager is open
  Relate:PROJECT.Open                                      ! File PROJECT used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:PROJECT,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,PRO:PRODTYPEX)                        ! Add the sort order for PRO:PRODTYPEX for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,PRO:PRODUCT,,BRW1)             ! Initialize the browse locator using  using key: PRO:PRODTYPEX , PRO:PRODUCT
  BRW1.AddSortOrder(,PRO:INTEG_35)                         ! Add the sort order for PRO:INTEG_35 for sort order 2
  BRW1.AddLocator(BRW1::Sort2:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort2:Locator.Init(,PRO:PROJ_ID,,BRW1)             ! Initialize the browse locator using  using key: PRO:INTEG_35 , PRO:PROJ_ID
  BRW1.AddSortOrder(,PRO:RDB_11)                           ! Add the sort order for PRO:RDB_11 for sort order 3
  BRW1.AddLocator(BRW1::Sort3:Locator)                     ! Browse has a locator for sort order 3
  BRW1::Sort3:Locator.Init(,PRO:PROJ_NAME,,BRW1)           ! Initialize the browse locator using  using key: PRO:RDB_11 , PRO:PROJ_NAME
  BRW1.AddSortOrder(,PRO:INTEG_36)                         ! Add the sort order for PRO:INTEG_36 for sort order 4
  BRW1.AddRange(PRO:TEAM_LEADER,Relate:PROJECT,Relate:EMPLOYEE) ! Add file relationship range limit for sort order 4
  BRW1.AddField(PRO:PROJ_ID,BRW1.Q.PRO:PROJ_ID)            ! Field PRO:PROJ_ID is a hot field or requires assignment from browse
  BRW1.AddField(PRO:PROJ_NAME,BRW1.Q.PRO:PROJ_NAME)        ! Field PRO:PROJ_NAME is a hot field or requires assignment from browse
  BRW1.AddField(PRO:TEAM_LEADER,BRW1.Q.PRO:TEAM_LEADER)    ! Field PRO:TEAM_LEADER is a hot field or requires assignment from browse
  BRW1.AddField(PRO:PRODUCT,BRW1.Q.PRO:PRODUCT)            ! Field PRO:PRODUCT is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('BrowsePROJECT',QuickWindow)                ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AskProcedure = 1
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:EMPLOYEE.Close
    Relate:PROJECT.Close
  END
  IF SELF.Opened
    INIMgr.Update('BrowsePROJECT',QuickWindow)             ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdatePROJECT
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?SelectEMPLOYEE
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectEMPLOYEE()
      ThisWindow.Reset
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END
  SELF.ViewControl = ?View:2                               ! Setup the control used to initiate view only mode


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSIF CHOICE(?CurrentTab) = 4
    RETURN SELF.SetSort(3,Force)
  ELSE
    RETURN SELF.SetSort(4,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the PROJ_DEPT_BUDGET file
!!! </summary>
BrowsePROJ_DEPT_BUDGET PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(PROJ_DEPT_BUDGET)
                       PROJECT(PRO2:FISCAL_YEAR)
                       PROJECT(PRO2:PROJ_ID)
                       PROJECT(PRO2:DEPT_NO)
                       PROJECT(PRO2:QUART_HEAD_CNT)
                       PROJECT(PRO2:PROJECTED_BUDGET)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
PRO2:FISCAL_YEAR       LIKE(PRO2:FISCAL_YEAR)         !List box control field - type derived from field
PRO2:PROJ_ID           LIKE(PRO2:PROJ_ID)             !List box control field - type derived from field
PRO2:DEPT_NO           LIKE(PRO2:DEPT_NO)             !List box control field - type derived from field
PRO2:QUART_HEAD_CNT    LIKE(PRO2:QUART_HEAD_CNT)      !List box control field - type derived from field
PRO2:PROJECTED_BUDGET  LIKE(PRO2:PROJECTED_BUDGET)    !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the PROJ_DEPT_BUDGET file'),AT(,,292,198),FONT('MS Sans Serif',8,,FONT:regular, |
  CHARSET:DEFAULT),RESIZE,CENTER,GRAY,IMM,MDI,HLP('BrowsePROJ_DEPT_BUDGET'),SYSTEM
                       LIST,AT(8,30,276,124),USE(?Browse:1),HVSCROLL,FORMAT('64R(2)|M~FISCAL YEAR~C(0)@n-14@32' & |
  'L(2)|M~PROJ ID~L(2)@s5@32L(2)|M~DEPT NO~L(2)@s3@80L(2)|M~QUART HEAD CNT~L(2)@s45@76D' & |
  '(12)|M~PROJECTED BUDGET~C(0)@n-17.2@'),FROM(Queue:Browse:1),IMM,MSG('Browsing the PR' & |
  'OJ_DEPT_BUDGET file')
                       BUTTON('&View'),AT(76,158,49,14),USE(?View:2),LEFT,ICON('WAVIEW.ICO'),FLAT,MSG('View Record'), |
  TIP('View Record')
                       BUTTON('&Insert'),AT(129,158,49,14),USE(?Insert:3),LEFT,ICON('WAINSERT.ICO'),FLAT,MSG('Insert a Record'), |
  TIP('Insert a Record')
                       BUTTON('&Change'),AT(182,158,49,14),USE(?Change:3),LEFT,ICON('WACHANGE.ICO'),DEFAULT,FLAT, |
  MSG('Change the Record'),TIP('Change the Record')
                       BUTTON('&Delete'),AT(235,158,49,14),USE(?Delete:3),LEFT,ICON('WADELETE.ICO'),FLAT,MSG('Delete the Record'), |
  TIP('Delete the Record')
                       SHEET,AT(4,4,284,172),USE(?CurrentTab)
                         TAB('&1) INTEG_47'),USE(?Tab:2)
                           BUTTON('Select DEPARTMENT'),AT(8,158,118,14),USE(?SelectDEPARTMENT),LEFT,ICON('WAPARENT.ICO'), |
  FLAT,MSG('Select Parent Field'),TIP('Select Parent Field')
                         END
                         TAB('&2) INTEG_48'),USE(?Tab:3)
                           BUTTON('Select PROJECT'),AT(8,158,118,14),USE(?SelectPROJECT),LEFT,ICON('WAPARENT.ICO'),FLAT, |
  MSG('Select Parent Field'),TIP('Select Parent Field')
                         END
                         TAB('&3) INTEG_46'),USE(?Tab:4)
                         END
                       END
                       BUTTON('&Close'),AT(186,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(239,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort2:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 3
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowsePROJ_DEPT_BUDGET')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('PRO2:FISCAL_YEAR',PRO2:FISCAL_YEAR)                ! Added by: BrowseBox(ABC)
  BIND('PRO2:PROJ_ID',PRO2:PROJ_ID)                        ! Added by: BrowseBox(ABC)
  BIND('PRO2:DEPT_NO',PRO2:DEPT_NO)                        ! Added by: BrowseBox(ABC)
  BIND('PRO2:QUART_HEAD_CNT',PRO2:QUART_HEAD_CNT)          ! Added by: BrowseBox(ABC)
  BIND('PRO2:PROJECTED_BUDGET',PRO2:PROJECTED_BUDGET)      ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:DEPARTMENT.Open                                   ! File DEPARTMENT used by this procedure, so make sure it's RelationManager is open
  Relate:PROJECT.Open                                      ! File PROJECT used by this procedure, so make sure it's RelationManager is open
  Relate:PROJ_DEPT_BUDGET.Open                             ! File PROJ_DEPT_BUDGET used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:PROJ_DEPT_BUDGET,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,PRO2:INTEG_48)                        ! Add the sort order for PRO2:INTEG_48 for sort order 1
  BRW1.AddRange(PRO2:PROJ_ID,Relate:PROJ_DEPT_BUDGET,Relate:PROJECT) ! Add file relationship range limit for sort order 1
  BRW1.AddSortOrder(,PRO2:INTEG_46)                        ! Add the sort order for PRO2:INTEG_46 for sort order 2
  BRW1.AddLocator(BRW1::Sort2:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort2:Locator.Init(,PRO2:FISCAL_YEAR,,BRW1)        ! Initialize the browse locator using  using key: PRO2:INTEG_46 , PRO2:FISCAL_YEAR
  BRW1.AddSortOrder(,PRO2:INTEG_47)                        ! Add the sort order for PRO2:INTEG_47 for sort order 3
  BRW1.AddRange(PRO2:DEPT_NO,Relate:PROJ_DEPT_BUDGET,Relate:DEPARTMENT) ! Add file relationship range limit for sort order 3
  BRW1.AddField(PRO2:FISCAL_YEAR,BRW1.Q.PRO2:FISCAL_YEAR)  ! Field PRO2:FISCAL_YEAR is a hot field or requires assignment from browse
  BRW1.AddField(PRO2:PROJ_ID,BRW1.Q.PRO2:PROJ_ID)          ! Field PRO2:PROJ_ID is a hot field or requires assignment from browse
  BRW1.AddField(PRO2:DEPT_NO,BRW1.Q.PRO2:DEPT_NO)          ! Field PRO2:DEPT_NO is a hot field or requires assignment from browse
  BRW1.AddField(PRO2:QUART_HEAD_CNT,BRW1.Q.PRO2:QUART_HEAD_CNT) ! Field PRO2:QUART_HEAD_CNT is a hot field or requires assignment from browse
  BRW1.AddField(PRO2:PROJECTED_BUDGET,BRW1.Q.PRO2:PROJECTED_BUDGET) ! Field PRO2:PROJECTED_BUDGET is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('BrowsePROJ_DEPT_BUDGET',QuickWindow)       ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AskProcedure = 1
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:DEPARTMENT.Close
    Relate:PROJECT.Close
    Relate:PROJ_DEPT_BUDGET.Close
  END
  IF SELF.Opened
    INIMgr.Update('BrowsePROJ_DEPT_BUDGET',QuickWindow)    ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdatePROJ_DEPT_BUDGET
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?SelectDEPARTMENT
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectDEPARTMENT()
      ThisWindow.Reset
    OF ?SelectPROJECT
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectPROJECT()
      ThisWindow.Reset
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END
  SELF.ViewControl = ?View:2                               ! Setup the control used to initiate view only mode


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSE
    RETURN SELF.SetSort(3,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

