

   MEMBER('Firebird.clw')                                  ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('FIREBIRD002.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('FIREBIRD003.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('FIREBIRD004.INC'),ONCE        !Req'd for module callout resolution
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the SALARY_HISTORY file
!!! </summary>
BrowseSALARY_HISTORY PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(SALARY_HISTORY)
                       PROJECT(SAL:EMP_NO)
                       PROJECT(SAL:CHANGE_DATE_DATE)
                       PROJECT(SAL:CHANGE_DATE_TIME)
                       PROJECT(SAL:UPDATER_ID)
                       PROJECT(SAL:OLD_SALARY)
                       PROJECT(SAL:PERCENT_CHANGE)
                       PROJECT(SAL:NEW_SALARY)
                       PROJECT(SAL:CHANGE_DATE)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
SAL:EMP_NO             LIKE(SAL:EMP_NO)               !List box control field - type derived from field
SAL:CHANGE_DATE_DATE   LIKE(SAL:CHANGE_DATE_DATE)     !List box control field - type derived from field
SAL:CHANGE_DATE_TIME   LIKE(SAL:CHANGE_DATE_TIME)     !List box control field - type derived from field
SAL:UPDATER_ID         LIKE(SAL:UPDATER_ID)           !List box control field - type derived from field
SAL:OLD_SALARY         LIKE(SAL:OLD_SALARY)           !List box control field - type derived from field
SAL:PERCENT_CHANGE     LIKE(SAL:PERCENT_CHANGE)       !List box control field - type derived from field
SAL:NEW_SALARY         LIKE(SAL:NEW_SALARY)           !List box control field - type derived from field
SAL:CHANGE_DATE        LIKE(SAL:CHANGE_DATE)          !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the SALARY_HISTORY file'),AT(,,358,198),FONT('MS Sans Serif',8,,FONT:regular, |
  CHARSET:DEFAULT),RESIZE,CENTER,GRAY,IMM,MDI,HLP('BrowseSALARY_HISTORY'),SYSTEM
                       LIST,AT(8,30,342,124),USE(?Browse:1),HVSCROLL,FORMAT('36R(2)|M~EMP NO~C(0)@n-7@80R(2)|M' & |
  '~CHANGE DATE DATE~C(0)@d17@80R(2)|M~CHANGE DATE TIME~C(0)@t7@80L(2)|M~UPDATER ID~L(2' & |
  ')@s20@64D(18)|M~OLD SALARY~C(0)@n-14.2@60D(12)|M~PERCENT CHANGE~C(0)@n10.2@44D(12)|M' & |
  '~NEW SALARY~C(0)@n10.2@'),FROM(Queue:Browse:1),IMM,MSG('Browsing the SALARY_HISTORY file')
                       BUTTON('&View'),AT(142,158,49,14),USE(?View:2),LEFT,ICON('WAVIEW.ICO'),FLAT,MSG('View Record'), |
  TIP('View Record')
                       BUTTON('&Insert'),AT(195,158,49,14),USE(?Insert:3),LEFT,ICON('WAINSERT.ICO'),FLAT,MSG('Insert a Record'), |
  TIP('Insert a Record')
                       BUTTON('&Change'),AT(248,158,49,14),USE(?Change:3),LEFT,ICON('WACHANGE.ICO'),DEFAULT,FLAT, |
  MSG('Change the Record'),TIP('Change the Record')
                       BUTTON('&Delete'),AT(301,158,49,14),USE(?Delete:3),LEFT,ICON('WADELETE.ICO'),FLAT,MSG('Delete the Record'), |
  TIP('Delete the Record')
                       SHEET,AT(4,4,350,172),USE(?CurrentTab)
                         TAB('&1) CHANGEX'),USE(?Tab:2)
                         END
                         TAB('&2) UPDATERX'),USE(?Tab:3)
                         END
                         TAB('&3) INTEG_56'),USE(?Tab:4)
                           BUTTON('Select EMPLOYEE'),AT(8,158,118,14),USE(?SelectEMPLOYEE),LEFT,ICON('WAPARENT.ICO'), |
  FLAT,MSG('Select Parent Field'),TIP('Select Parent Field')
                         END
                         TAB('&4) INTEG_55'),USE(?Tab:5)
                         END
                       END
                       BUTTON('&Close'),AT(252,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(305,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort3:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 4
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseSALARY_HISTORY')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('SAL:EMP_NO',SAL:EMP_NO)                            ! Added by: BrowseBox(ABC)
  BIND('SAL:UPDATER_ID',SAL:UPDATER_ID)                    ! Added by: BrowseBox(ABC)
  BIND('SAL:OLD_SALARY',SAL:OLD_SALARY)                    ! Added by: BrowseBox(ABC)
  BIND('SAL:PERCENT_CHANGE',SAL:PERCENT_CHANGE)            ! Added by: BrowseBox(ABC)
  BIND('SAL:NEW_SALARY',SAL:NEW_SALARY)                    ! Added by: BrowseBox(ABC)
  BIND('SAL:CHANGE_DATE',SAL:CHANGE_DATE)                  ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:EMPLOYEE.Open                                     ! File EMPLOYEE used by this procedure, so make sure it's RelationManager is open
  Relate:SALARY_HISTORY.Open                               ! File SALARY_HISTORY used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:SALARY_HISTORY,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,SAL:UPDATERX)                         ! Add the sort order for SAL:UPDATERX for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,SAL:UPDATER_ID,,BRW1)          ! Initialize the browse locator using  using key: SAL:UPDATERX , SAL:UPDATER_ID
  BRW1.AddSortOrder(,SAL:INTEG_56)                         ! Add the sort order for SAL:INTEG_56 for sort order 2
  BRW1.AddRange(SAL:EMP_NO,Relate:SALARY_HISTORY,Relate:EMPLOYEE) ! Add file relationship range limit for sort order 2
  BRW1.AddSortOrder(,SAL:INTEG_55)                         ! Add the sort order for SAL:INTEG_55 for sort order 3
  BRW1.AddLocator(BRW1::Sort3:Locator)                     ! Browse has a locator for sort order 3
  BRW1::Sort3:Locator.Init(,SAL:EMP_NO,,BRW1)              ! Initialize the browse locator using  using key: SAL:INTEG_55 , SAL:EMP_NO
  BRW1.AddSortOrder(,SAL:CHANGEX)                          ! Add the sort order for SAL:CHANGEX for sort order 4
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 4
  BRW1::Sort0:Locator.Init(,SAL:CHANGE_DATE,,BRW1)         ! Initialize the browse locator using  using key: SAL:CHANGEX , SAL:CHANGE_DATE
  BRW1.AddField(SAL:EMP_NO,BRW1.Q.SAL:EMP_NO)              ! Field SAL:EMP_NO is a hot field or requires assignment from browse
  BRW1.AddField(SAL:CHANGE_DATE_DATE,BRW1.Q.SAL:CHANGE_DATE_DATE) ! Field SAL:CHANGE_DATE_DATE is a hot field or requires assignment from browse
  BRW1.AddField(SAL:CHANGE_DATE_TIME,BRW1.Q.SAL:CHANGE_DATE_TIME) ! Field SAL:CHANGE_DATE_TIME is a hot field or requires assignment from browse
  BRW1.AddField(SAL:UPDATER_ID,BRW1.Q.SAL:UPDATER_ID)      ! Field SAL:UPDATER_ID is a hot field or requires assignment from browse
  BRW1.AddField(SAL:OLD_SALARY,BRW1.Q.SAL:OLD_SALARY)      ! Field SAL:OLD_SALARY is a hot field or requires assignment from browse
  BRW1.AddField(SAL:PERCENT_CHANGE,BRW1.Q.SAL:PERCENT_CHANGE) ! Field SAL:PERCENT_CHANGE is a hot field or requires assignment from browse
  BRW1.AddField(SAL:NEW_SALARY,BRW1.Q.SAL:NEW_SALARY)      ! Field SAL:NEW_SALARY is a hot field or requires assignment from browse
  BRW1.AddField(SAL:CHANGE_DATE,BRW1.Q.SAL:CHANGE_DATE)    ! Field SAL:CHANGE_DATE is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('BrowseSALARY_HISTORY',QuickWindow)         ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AskProcedure = 1
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:EMPLOYEE.Close
    Relate:SALARY_HISTORY.Close
  END
  IF SELF.Opened
    INIMgr.Update('BrowseSALARY_HISTORY',QuickWindow)      ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateSALARY_HISTORY
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?SelectEMPLOYEE
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectEMPLOYEE()
      ThisWindow.Reset
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END
  SELF.ViewControl = ?View:2                               ! Setup the control used to initiate view only mode


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSIF CHOICE(?CurrentTab) = 4
    RETURN SELF.SetSort(3,Force)
  ELSE
    RETURN SELF.SetSort(4,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the SALES file
!!! </summary>
BrowseSALES PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(SALES)
                       PROJECT(SAL2:PO_NUMBER)
                       PROJECT(SAL2:CUST_NO)
                       PROJECT(SAL2:SALES_REP)
                       PROJECT(SAL2:ORDER_STATUS)
                       PROJECT(SAL2:ORDER_DATE_DATE)
                       PROJECT(SAL2:ORDER_DATE_TIME)
                       PROJECT(SAL2:SHIP_DATE_DATE)
                       PROJECT(SAL2:SHIP_DATE_TIME)
                       PROJECT(SAL2:DATE_NEEDED_DATE)
                       PROJECT(SAL2:ITEM_TYPE)
                       PROJECT(SAL2:QTY_ORDERED)
                       PROJECT(SAL2:PAID)
                       PROJECT(SAL2:DATE_NEEDED)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
SAL2:PO_NUMBER         LIKE(SAL2:PO_NUMBER)           !List box control field - type derived from field
SAL2:CUST_NO           LIKE(SAL2:CUST_NO)             !List box control field - type derived from field
SAL2:SALES_REP         LIKE(SAL2:SALES_REP)           !List box control field - type derived from field
SAL2:ORDER_STATUS      LIKE(SAL2:ORDER_STATUS)        !List box control field - type derived from field
SAL2:ORDER_DATE_DATE   LIKE(SAL2:ORDER_DATE_DATE)     !List box control field - type derived from field
SAL2:ORDER_DATE_TIME   LIKE(SAL2:ORDER_DATE_TIME)     !List box control field - type derived from field
SAL2:SHIP_DATE_DATE    LIKE(SAL2:SHIP_DATE_DATE)      !List box control field - type derived from field
SAL2:SHIP_DATE_TIME    LIKE(SAL2:SHIP_DATE_TIME)      !List box control field - type derived from field
SAL2:DATE_NEEDED_DATE  LIKE(SAL2:DATE_NEEDED_DATE)    !List box control field - type derived from field
SAL2:ITEM_TYPE         LIKE(SAL2:ITEM_TYPE)           !Browse key field - type derived from field
SAL2:QTY_ORDERED       LIKE(SAL2:QTY_ORDERED)         !Browse key field - type derived from field
SAL2:PAID              LIKE(SAL2:PAID)                !Browse key field - type derived from field
SAL2:DATE_NEEDED       LIKE(SAL2:DATE_NEEDED)         !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the SALES file'),AT(,,358,198),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('BrowseSALES'),SYSTEM
                       LIST,AT(8,30,342,124),USE(?Browse:1),HVSCROLL,FORMAT('40L(2)|M~PO NUMBER~L(2)@s8@64R(2)' & |
  '|M~CUST NO~C(0)@n-14@40R(2)|M~SALES REP~C(0)@n-7@52L(2)|M~ORDER STATUS~L(2)@s7@80R(2' & |
  ')|M~ORDER DATE DATE~C(0)@d17@80R(2)|M~ORDER DATE TIME~C(0)@t7@80R(2)|M~SHIP DATE DAT' & |
  'E~C(0)@d17@80R(2)|M~SHIP DATE TIME~C(0)@t7@80R(2)|M~DATE NEEDED DATE~C(0)@d17@'),FROM(Queue:Browse:1), |
  IMM,MSG('Browsing the SALES file')
                       BUTTON('&View'),AT(142,158,49,14),USE(?View:2),LEFT,ICON('WAVIEW.ICO'),FLAT,MSG('View Record'), |
  TIP('View Record')
                       BUTTON('&Insert'),AT(195,158,49,14),USE(?Insert:3),LEFT,ICON('WAINSERT.ICO'),FLAT,MSG('Insert a Record'), |
  TIP('Insert a Record')
                       BUTTON('&Change'),AT(248,158,49,14),USE(?Change:3),LEFT,ICON('WACHANGE.ICO'),DEFAULT,FLAT, |
  MSG('Change the Record'),TIP('Change the Record')
                       BUTTON('&Delete'),AT(301,158,49,14),USE(?Delete:3),LEFT,ICON('WADELETE.ICO'),FLAT,MSG('Delete the Record'), |
  TIP('Delete the Record')
                       SHEET,AT(4,4,350,172),USE(?CurrentTab)
                         TAB('&1) NEEDX'),USE(?Tab:2)
                         END
                         TAB('&2) QTYX'),USE(?Tab:3)
                         END
                         TAB('&3) SALESTATX'),USE(?Tab:4)
                         END
                         TAB('&4) INTEG_77'),USE(?Tab:5)
                           BUTTON('Select CUSTOMER'),AT(8,158,118,14),USE(?SelectCUSTOMER),LEFT,ICON('WAPARENT.ICO'), |
  FLAT,MSG('Select Parent Field'),TIP('Select Parent Field')
                         END
                         TAB('&5) INTEG_78'),USE(?Tab:6)
                           BUTTON('Select EMPLOYEE'),AT(8,158,118,14),USE(?SelectEMPLOYEE),LEFT,ICON('WAPARENT.ICO'), |
  FLAT,MSG('Select Parent Field'),TIP('Select Parent Field')
                         END
                         TAB('&6) INTEG_76'),USE(?Tab:7)
                         END
                       END
                       BUTTON('&Close'),AT(252,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(305,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort2:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 3
BRW1::Sort5:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 6
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseSALES')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('SAL2:PO_NUMBER',SAL2:PO_NUMBER)                    ! Added by: BrowseBox(ABC)
  BIND('SAL2:CUST_NO',SAL2:CUST_NO)                        ! Added by: BrowseBox(ABC)
  BIND('SAL2:SALES_REP',SAL2:SALES_REP)                    ! Added by: BrowseBox(ABC)
  BIND('SAL2:ORDER_STATUS',SAL2:ORDER_STATUS)              ! Added by: BrowseBox(ABC)
  BIND('SAL2:ITEM_TYPE',SAL2:ITEM_TYPE)                    ! Added by: BrowseBox(ABC)
  BIND('SAL2:QTY_ORDERED',SAL2:QTY_ORDERED)                ! Added by: BrowseBox(ABC)
  BIND('SAL2:DATE_NEEDED',SAL2:DATE_NEEDED)                ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:CUSTOMER.Open                                     ! File CUSTOMER used by this procedure, so make sure it's RelationManager is open
  Relate:EMPLOYEE.Open                                     ! File EMPLOYEE used by this procedure, so make sure it's RelationManager is open
  Relate:SALES.Open                                        ! File SALES used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:SALES,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,SAL2:QTYX)                            ! Add the sort order for SAL2:QTYX for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,SAL2:ITEM_TYPE,,BRW1)          ! Initialize the browse locator using  using key: SAL2:QTYX , SAL2:ITEM_TYPE
  BRW1.AddSortOrder(,SAL2:SALESTATX)                       ! Add the sort order for SAL2:SALESTATX for sort order 2
  BRW1.AddLocator(BRW1::Sort2:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort2:Locator.Init(,SAL2:ORDER_STATUS,,BRW1)       ! Initialize the browse locator using  using key: SAL2:SALESTATX , SAL2:ORDER_STATUS
  BRW1.AddSortOrder(,SAL2:INTEG_77)                        ! Add the sort order for SAL2:INTEG_77 for sort order 3
  BRW1.AddRange(SAL2:CUST_NO,Relate:SALES,Relate:CUSTOMER) ! Add file relationship range limit for sort order 3
  BRW1.AddSortOrder(,SAL2:INTEG_78)                        ! Add the sort order for SAL2:INTEG_78 for sort order 4
  BRW1.AddRange(SAL2:SALES_REP,Relate:SALES,Relate:EMPLOYEE) ! Add file relationship range limit for sort order 4
  BRW1.AddSortOrder(,SAL2:INTEG_76)                        ! Add the sort order for SAL2:INTEG_76 for sort order 5
  BRW1.AddLocator(BRW1::Sort5:Locator)                     ! Browse has a locator for sort order 5
  BRW1::Sort5:Locator.Init(,SAL2:PO_NUMBER,,BRW1)          ! Initialize the browse locator using  using key: SAL2:INTEG_76 , SAL2:PO_NUMBER
  BRW1.AddSortOrder(,SAL2:NEEDX)                           ! Add the sort order for SAL2:NEEDX for sort order 6
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 6
  BRW1::Sort0:Locator.Init(,SAL2:DATE_NEEDED,,BRW1)        ! Initialize the browse locator using  using key: SAL2:NEEDX , SAL2:DATE_NEEDED
  BRW1.AddField(SAL2:PO_NUMBER,BRW1.Q.SAL2:PO_NUMBER)      ! Field SAL2:PO_NUMBER is a hot field or requires assignment from browse
  BRW1.AddField(SAL2:CUST_NO,BRW1.Q.SAL2:CUST_NO)          ! Field SAL2:CUST_NO is a hot field or requires assignment from browse
  BRW1.AddField(SAL2:SALES_REP,BRW1.Q.SAL2:SALES_REP)      ! Field SAL2:SALES_REP is a hot field or requires assignment from browse
  BRW1.AddField(SAL2:ORDER_STATUS,BRW1.Q.SAL2:ORDER_STATUS) ! Field SAL2:ORDER_STATUS is a hot field or requires assignment from browse
  BRW1.AddField(SAL2:ORDER_DATE_DATE,BRW1.Q.SAL2:ORDER_DATE_DATE) ! Field SAL2:ORDER_DATE_DATE is a hot field or requires assignment from browse
  BRW1.AddField(SAL2:ORDER_DATE_TIME,BRW1.Q.SAL2:ORDER_DATE_TIME) ! Field SAL2:ORDER_DATE_TIME is a hot field or requires assignment from browse
  BRW1.AddField(SAL2:SHIP_DATE_DATE,BRW1.Q.SAL2:SHIP_DATE_DATE) ! Field SAL2:SHIP_DATE_DATE is a hot field or requires assignment from browse
  BRW1.AddField(SAL2:SHIP_DATE_TIME,BRW1.Q.SAL2:SHIP_DATE_TIME) ! Field SAL2:SHIP_DATE_TIME is a hot field or requires assignment from browse
  BRW1.AddField(SAL2:DATE_NEEDED_DATE,BRW1.Q.SAL2:DATE_NEEDED_DATE) ! Field SAL2:DATE_NEEDED_DATE is a hot field or requires assignment from browse
  BRW1.AddField(SAL2:ITEM_TYPE,BRW1.Q.SAL2:ITEM_TYPE)      ! Field SAL2:ITEM_TYPE is a hot field or requires assignment from browse
  BRW1.AddField(SAL2:QTY_ORDERED,BRW1.Q.SAL2:QTY_ORDERED)  ! Field SAL2:QTY_ORDERED is a hot field or requires assignment from browse
  BRW1.AddField(SAL2:PAID,BRW1.Q.SAL2:PAID)                ! Field SAL2:PAID is a hot field or requires assignment from browse
  BRW1.AddField(SAL2:DATE_NEEDED,BRW1.Q.SAL2:DATE_NEEDED)  ! Field SAL2:DATE_NEEDED is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('BrowseSALES',QuickWindow)                  ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AskProcedure = 1
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:CUSTOMER.Close
    Relate:EMPLOYEE.Close
    Relate:SALES.Close
  END
  IF SELF.Opened
    INIMgr.Update('BrowseSALES',QuickWindow)               ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateSALES
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?SelectCUSTOMER
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectCUSTOMER()
      ThisWindow.Reset
    OF ?SelectEMPLOYEE
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectEMPLOYEE()
      ThisWindow.Reset
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END
  SELF.ViewControl = ?View:2                               ! Setup the control used to initiate view only mode


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSIF CHOICE(?CurrentTab) = 4
    RETURN SELF.SetSort(3,Force)
  ELSIF CHOICE(?CurrentTab) = 5
    RETURN SELF.SetSort(4,Force)
  ELSIF CHOICE(?CurrentTab) = 6
    RETURN SELF.SetSort(5,Force)
  ELSE
    RETURN SELF.SetSort(6,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the DEPARTMENT2 file
!!! </summary>
BrowseDEPARTMENT2 PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(DEPARTMENT2)
                       PROJECT(DEP1:DEPT_NO)
                       PROJECT(DEP1:DEPARTMENT)
                       PROJECT(DEP1:HEAD_DEPT)
                       PROJECT(DEP1:MNGR_NO)
                       PROJECT(DEP1:BUDGET)
                       PROJECT(DEP1:LOCATION)
                       PROJECT(DEP1:PHONE_NO)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
DEP1:DEPT_NO           LIKE(DEP1:DEPT_NO)             !List box control field - type derived from field
DEP1:DEPARTMENT        LIKE(DEP1:DEPARTMENT)          !List box control field - type derived from field
DEP1:HEAD_DEPT         LIKE(DEP1:HEAD_DEPT)           !List box control field - type derived from field
DEP1:MNGR_NO           LIKE(DEP1:MNGR_NO)             !List box control field - type derived from field
DEP1:BUDGET            LIKE(DEP1:BUDGET)              !List box control field - type derived from field
DEP1:LOCATION          LIKE(DEP1:LOCATION)            !List box control field - type derived from field
DEP1:PHONE_NO          LIKE(DEP1:PHONE_NO)            !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the DEPARTMENT2 file'),AT(,,358,198),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('BrowseDEPARTMENT2'),SYSTEM
                       LIST,AT(8,30,342,124),USE(?Browse:1),HVSCROLL,FORMAT('32L(2)|M~DEPT NO~L(2)@s3@80L(2)|M' & |
  '~DEPARTMENT~L(2)@s25@40L(2)|M~HEAD DEPT~L(2)@s3@36R(2)|M~MNGR NO~C(0)@n-7@76D(32)|M~' & |
  'BUDGET~C(0)@n-17.2@64L(2)|M~LOCATION~L(2)@s15@80L(2)|M~PHONE NO~L(2)@s20@'),FROM(Queue:Browse:1), |
  IMM,MSG('Browsing the DEPARTMENT2 file')
                       BUTTON('&View'),AT(142,158,49,14),USE(?View:2),LEFT,ICON('WAVIEW.ICO'),FLAT,MSG('View Record'), |
  TIP('View Record')
                       BUTTON('&Insert'),AT(195,158,49,14),USE(?Insert:3),LEFT,ICON('WAINSERT.ICO'),FLAT,MSG('Insert a Record'), |
  TIP('Insert a Record')
                       BUTTON('&Change'),AT(248,158,49,14),USE(?Change:3),LEFT,ICON('WACHANGE.ICO'),DEFAULT,FLAT, |
  MSG('Change the Record'),TIP('Change the Record')
                       BUTTON('&Delete'),AT(301,158,49,14),USE(?Delete:3),LEFT,ICON('WADELETE.ICO'),FLAT,MSG('Delete the Record'), |
  TIP('Delete the Record')
                       SHEET,AT(4,4,350,172),USE(?CurrentTab)
                         TAB('&1) BUDGETX'),USE(?Tab:2)
                         END
                         TAB('&2) INTEG_31'),USE(?Tab:3)
                         END
                         TAB('&3) INTEG_17'),USE(?Tab:4)
                         END
                         TAB('&4) INTEG_16'),USE(?Tab:5)
                         END
                         TAB('&5) RDB_4'),USE(?Tab:6)
                         END
                       END
                       BUTTON('&Close'),AT(252,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(305,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort2:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 3
BRW1::Sort3:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 4
BRW1::Sort4:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 5
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseDEPARTMENT2')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('DEP1:DEPT_NO',DEP1:DEPT_NO)                        ! Added by: BrowseBox(ABC)
  BIND('DEP1:HEAD_DEPT',DEP1:HEAD_DEPT)                    ! Added by: BrowseBox(ABC)
  BIND('DEP1:MNGR_NO',DEP1:MNGR_NO)                        ! Added by: BrowseBox(ABC)
  BIND('DEP1:PHONE_NO',DEP1:PHONE_NO)                      ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:DEPARTMENT2.Open                                  ! File DEPARTMENT2 used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:DEPARTMENT2,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,DEP1:INTEG_31)                        ! Add the sort order for DEP1:INTEG_31 for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,DEP1:MNGR_NO,,BRW1)            ! Initialize the browse locator using  using key: DEP1:INTEG_31 , DEP1:MNGR_NO
  BRW1.AddSortOrder(,DEP1:INTEG_17)                        ! Add the sort order for DEP1:INTEG_17 for sort order 2
  BRW1.AddLocator(BRW1::Sort2:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort2:Locator.Init(,DEP1:HEAD_DEPT,,BRW1)          ! Initialize the browse locator using  using key: DEP1:INTEG_17 , DEP1:HEAD_DEPT
  BRW1.AddSortOrder(,DEP1:INTEG_16)                        ! Add the sort order for DEP1:INTEG_16 for sort order 3
  BRW1.AddLocator(BRW1::Sort3:Locator)                     ! Browse has a locator for sort order 3
  BRW1::Sort3:Locator.Init(,DEP1:DEPT_NO,,BRW1)            ! Initialize the browse locator using  using key: DEP1:INTEG_16 , DEP1:DEPT_NO
  BRW1.AddSortOrder(,DEP1:RDB_4)                           ! Add the sort order for DEP1:RDB_4 for sort order 4
  BRW1.AddLocator(BRW1::Sort4:Locator)                     ! Browse has a locator for sort order 4
  BRW1::Sort4:Locator.Init(,DEP1:DEPARTMENT,,BRW1)         ! Initialize the browse locator using  using key: DEP1:RDB_4 , DEP1:DEPARTMENT
  BRW1.AddSortOrder(,DEP1:BUDGETX)                         ! Add the sort order for DEP1:BUDGETX for sort order 5
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 5
  BRW1::Sort0:Locator.Init(,DEP1:BUDGET,,BRW1)             ! Initialize the browse locator using  using key: DEP1:BUDGETX , DEP1:BUDGET
  BRW1.AddField(DEP1:DEPT_NO,BRW1.Q.DEP1:DEPT_NO)          ! Field DEP1:DEPT_NO is a hot field or requires assignment from browse
  BRW1.AddField(DEP1:DEPARTMENT,BRW1.Q.DEP1:DEPARTMENT)    ! Field DEP1:DEPARTMENT is a hot field or requires assignment from browse
  BRW1.AddField(DEP1:HEAD_DEPT,BRW1.Q.DEP1:HEAD_DEPT)      ! Field DEP1:HEAD_DEPT is a hot field or requires assignment from browse
  BRW1.AddField(DEP1:MNGR_NO,BRW1.Q.DEP1:MNGR_NO)          ! Field DEP1:MNGR_NO is a hot field or requires assignment from browse
  BRW1.AddField(DEP1:BUDGET,BRW1.Q.DEP1:BUDGET)            ! Field DEP1:BUDGET is a hot field or requires assignment from browse
  BRW1.AddField(DEP1:LOCATION,BRW1.Q.DEP1:LOCATION)        ! Field DEP1:LOCATION is a hot field or requires assignment from browse
  BRW1.AddField(DEP1:PHONE_NO,BRW1.Q.DEP1:PHONE_NO)        ! Field DEP1:PHONE_NO is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('BrowseDEPARTMENT2',QuickWindow)            ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AskProcedure = 1
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:DEPARTMENT2.Close
  END
  IF SELF.Opened
    INIMgr.Update('BrowseDEPARTMENT2',QuickWindow)         ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateDEPARTMENT2
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END
  SELF.ViewControl = ?View:2                               ! Setup the control used to initiate view only mode


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSIF CHOICE(?CurrentTab) = 4
    RETURN SELF.SetSort(3,Force)
  ELSIF CHOICE(?CurrentTab) = 5
    RETURN SELF.SetSort(4,Force)
  ELSE
    RETURN SELF.SetSort(5,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the DEPARTMENT3 file
!!! </summary>
BrowseDEPARTMENT3 PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(DEPARTMENT3)
                       PROJECT(DEP2:EMP_NO)
                       PROJECT(DEP2:FIRST_NAME)
                       PROJECT(DEP2:LAST_NAME)
                       PROJECT(DEP2:PHONE_EXT)
                       PROJECT(DEP2:HIRE_DATE_DATE)
                       PROJECT(DEP2:HIRE_DATE_TIME)
                       PROJECT(DEP2:DEPT_NO)
                       PROJECT(DEP2:JOB_CODE)
                       PROJECT(DEP2:JOB_GRADE)
                       PROJECT(DEP2:JOB_COUNTRY)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
DEP2:EMP_NO            LIKE(DEP2:EMP_NO)              !List box control field - type derived from field
DEP2:FIRST_NAME        LIKE(DEP2:FIRST_NAME)          !List box control field - type derived from field
DEP2:LAST_NAME         LIKE(DEP2:LAST_NAME)           !List box control field - type derived from field
DEP2:PHONE_EXT         LIKE(DEP2:PHONE_EXT)           !List box control field - type derived from field
DEP2:HIRE_DATE_DATE    LIKE(DEP2:HIRE_DATE_DATE)      !List box control field - type derived from field
DEP2:HIRE_DATE_TIME    LIKE(DEP2:HIRE_DATE_TIME)      !List box control field - type derived from field
DEP2:DEPT_NO           LIKE(DEP2:DEPT_NO)             !List box control field - type derived from field
DEP2:JOB_CODE          LIKE(DEP2:JOB_CODE)            !List box control field - type derived from field
DEP2:JOB_GRADE         LIKE(DEP2:JOB_GRADE)           !List box control field - type derived from field
DEP2:JOB_COUNTRY       LIKE(DEP2:JOB_COUNTRY)         !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the DEPARTMENT3 file'),AT(,,358,198),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('BrowseDEPARTMENT3'),SYSTEM
                       LIST,AT(8,30,342,124),USE(?Browse:1),HVSCROLL,FORMAT('36R(2)|M~EMP NO~C(0)@n-7@64L(2)|M' & |
  '~FIRST NAME~L(2)@s15@80L(2)|M~LAST NAME~L(2)@s20@40L(2)|M~PHONE EXT~L(2)@s4@80R(2)|M' & |
  '~HIRE DATE DATE~C(0)@d17@80R(2)|M~HIRE DATE TIME~C(0)@t7@32L(2)|M~DEPT NO~L(2)@s3@36' & |
  'L(2)|M~JOB CODE~L(2)@s5@40R(2)|M~JOB GRADE~C(0)@n-7@'),FROM(Queue:Browse:1),IMM,MSG('Browsing t' & |
  'he DEPARTMENT3 file')
                       BUTTON('&View'),AT(142,158,49,14),USE(?View:2),LEFT,ICON('WAVIEW.ICO'),FLAT,MSG('View Record'), |
  TIP('View Record')
                       BUTTON('&Insert'),AT(195,158,49,14),USE(?Insert:3),LEFT,ICON('WAINSERT.ICO'),FLAT,MSG('Insert a Record'), |
  TIP('Insert a Record')
                       BUTTON('&Change'),AT(248,158,49,14),USE(?Change:3),LEFT,ICON('WACHANGE.ICO'),DEFAULT,FLAT, |
  MSG('Change the Record'),TIP('Change the Record')
                       BUTTON('&Delete'),AT(301,158,49,14),USE(?Delete:3),LEFT,ICON('WADELETE.ICO'),FLAT,MSG('Delete the Record'), |
  TIP('Delete the Record')
                       SHEET,AT(4,4,350,172),USE(?CurrentTab)
                         TAB('&1) NAMEX'),USE(?Tab:2)
                         END
                         TAB('&2) INTEG_28'),USE(?Tab:3)
                         END
                         TAB('&3) INTEG_29'),USE(?Tab:4)
                         END
                         TAB('&4) INTEG_27'),USE(?Tab:5)
                         END
                       END
                       BUTTON('&Close'),AT(252,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(305,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort2:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 3
BRW1::Sort3:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 4
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseDEPARTMENT3')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('DEP2:EMP_NO',DEP2:EMP_NO)                          ! Added by: BrowseBox(ABC)
  BIND('DEP2:FIRST_NAME',DEP2:FIRST_NAME)                  ! Added by: BrowseBox(ABC)
  BIND('DEP2:LAST_NAME',DEP2:LAST_NAME)                    ! Added by: BrowseBox(ABC)
  BIND('DEP2:PHONE_EXT',DEP2:PHONE_EXT)                    ! Added by: BrowseBox(ABC)
  BIND('DEP2:DEPT_NO',DEP2:DEPT_NO)                        ! Added by: BrowseBox(ABC)
  BIND('DEP2:JOB_CODE',DEP2:JOB_CODE)                      ! Added by: BrowseBox(ABC)
  BIND('DEP2:JOB_GRADE',DEP2:JOB_GRADE)                    ! Added by: BrowseBox(ABC)
  BIND('DEP2:JOB_COUNTRY',DEP2:JOB_COUNTRY)                ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:DEPARTMENT3.Open                                  ! File DEPARTMENT3 used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:DEPARTMENT3,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,DEP2:INTEG_28)                        ! Add the sort order for DEP2:INTEG_28 for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,DEP2:DEPT_NO,,BRW1)            ! Initialize the browse locator using  using key: DEP2:INTEG_28 , DEP2:DEPT_NO
  BRW1.AddSortOrder(,DEP2:INTEG_29)                        ! Add the sort order for DEP2:INTEG_29 for sort order 2
  BRW1.AddLocator(BRW1::Sort2:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort2:Locator.Init(,DEP2:JOB_CODE,,BRW1)           ! Initialize the browse locator using  using key: DEP2:INTEG_29 , DEP2:JOB_CODE
  BRW1.AddSortOrder(,DEP2:INTEG_27)                        ! Add the sort order for DEP2:INTEG_27 for sort order 3
  BRW1.AddLocator(BRW1::Sort3:Locator)                     ! Browse has a locator for sort order 3
  BRW1::Sort3:Locator.Init(,DEP2:EMP_NO,,BRW1)             ! Initialize the browse locator using  using key: DEP2:INTEG_27 , DEP2:EMP_NO
  BRW1.AddSortOrder(,DEP2:NAMEX)                           ! Add the sort order for DEP2:NAMEX for sort order 4
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 4
  BRW1::Sort0:Locator.Init(,DEP2:LAST_NAME,,BRW1)          ! Initialize the browse locator using  using key: DEP2:NAMEX , DEP2:LAST_NAME
  BRW1.AddField(DEP2:EMP_NO,BRW1.Q.DEP2:EMP_NO)            ! Field DEP2:EMP_NO is a hot field or requires assignment from browse
  BRW1.AddField(DEP2:FIRST_NAME,BRW1.Q.DEP2:FIRST_NAME)    ! Field DEP2:FIRST_NAME is a hot field or requires assignment from browse
  BRW1.AddField(DEP2:LAST_NAME,BRW1.Q.DEP2:LAST_NAME)      ! Field DEP2:LAST_NAME is a hot field or requires assignment from browse
  BRW1.AddField(DEP2:PHONE_EXT,BRW1.Q.DEP2:PHONE_EXT)      ! Field DEP2:PHONE_EXT is a hot field or requires assignment from browse
  BRW1.AddField(DEP2:HIRE_DATE_DATE,BRW1.Q.DEP2:HIRE_DATE_DATE) ! Field DEP2:HIRE_DATE_DATE is a hot field or requires assignment from browse
  BRW1.AddField(DEP2:HIRE_DATE_TIME,BRW1.Q.DEP2:HIRE_DATE_TIME) ! Field DEP2:HIRE_DATE_TIME is a hot field or requires assignment from browse
  BRW1.AddField(DEP2:DEPT_NO,BRW1.Q.DEP2:DEPT_NO)          ! Field DEP2:DEPT_NO is a hot field or requires assignment from browse
  BRW1.AddField(DEP2:JOB_CODE,BRW1.Q.DEP2:JOB_CODE)        ! Field DEP2:JOB_CODE is a hot field or requires assignment from browse
  BRW1.AddField(DEP2:JOB_GRADE,BRW1.Q.DEP2:JOB_GRADE)      ! Field DEP2:JOB_GRADE is a hot field or requires assignment from browse
  BRW1.AddField(DEP2:JOB_COUNTRY,BRW1.Q.DEP2:JOB_COUNTRY)  ! Field DEP2:JOB_COUNTRY is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('BrowseDEPARTMENT3',QuickWindow)            ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AskProcedure = 1
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:DEPARTMENT3.Close
  END
  IF SELF.Opened
    INIMgr.Update('BrowseDEPARTMENT3',QuickWindow)         ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateDEPARTMENT3
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END
  SELF.ViewControl = ?View:2                               ! Setup the control used to initiate view only mode


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSIF CHOICE(?CurrentTab) = 4
    RETURN SELF.SetSort(3,Force)
  ELSE
    RETURN SELF.SetSort(4,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Form COUNTRY
!!! </summary>
UpdateCOUNTRY PROCEDURE 

CurrentTab           STRING(80)                            !
ActionMessage        CSTRING(40)                           !
History::COU:Record  LIKE(COU:RECORD),THREAD
QuickWindow          WINDOW('Form COUNTRY'),AT(,,163,70),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('UpdateCOUNTRY'),SYSTEM
                       SHEET,AT(4,4,155,44),USE(?CurrentTab)
                         TAB('&1) General'),USE(?Tab:1)
                           PROMPT('COUNTRY:'),AT(8,20),USE(?COU:COUNTRY:Prompt),TRN
                           ENTRY(@s15),AT(61,20,64,10),USE(COU:COUNTRY)
                           PROMPT('CURRENCY:'),AT(8,34),USE(?COU:CURRENCY:Prompt),TRN
                           ENTRY(@s10),AT(61,34,44,10),USE(COU:CURRENCY)
                         END
                       END
                       BUTTON('&OK'),AT(4,52,49,14),USE(?OK),LEFT,ICON('WAOK.ICO'),DEFAULT,FLAT,MSG('Accept dat' & |
  'a and close the window'),TIP('Accept data and close the window')
                       BUTTON('&Cancel'),AT(57,52,49,14),USE(?Cancel),LEFT,ICON('WACANCEL.ICO'),FLAT,MSG('Cancel operation'), |
  TIP('Cancel operation')
                       BUTTON('&Help'),AT(110,52,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Record Will Be Changed'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateCOUNTRY')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?COU:COUNTRY:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(COU:Record,History::COU:Record)
  SELF.AddHistoryField(?COU:COUNTRY,1)
  SELF.AddHistoryField(?COU:CURRENCY,2)
  SELF.AddUpdateFile(Access:COUNTRY)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:COUNTRY.Open                                      ! File COUNTRY used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:COUNTRY
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF SELF.Request = ViewRecord                             ! Configure controls for View Only mode
    ?COU:COUNTRY{PROP:ReadOnly} = True
    ?COU:CURRENCY{PROP:ReadOnly} = True
  END
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdateCOUNTRY',QuickWindow)                ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:COUNTRY.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateCOUNTRY',QuickWindow)             ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Select a COUNTRY Record
!!! </summary>
SelectCOUNTRY PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(COUNTRY)
                       PROJECT(COU:COUNTRY)
                       PROJECT(COU:CURRENCY)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
COU:COUNTRY            LIKE(COU:COUNTRY)              !List box control field - type derived from field
COU:CURRENCY           LIKE(COU:CURRENCY)             !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a COUNTRY Record'),AT(,,158,198),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('SelectCOUNTRY'),SYSTEM
                       LIST,AT(8,30,142,124),USE(?Browse:1),HVSCROLL,FORMAT('64L(2)|M~COUNTRY~L(2)@s15@44L(2)|' & |
  'M~CURRENCY~L(2)@s10@'),FROM(Queue:Browse:1),IMM,MSG('Browsing the COUNTRY file')
                       BUTTON('&Select'),AT(101,158,49,14),USE(?Select:2),LEFT,ICON('WASELECT.ICO'),FLAT,MSG('Select the Record'), |
  TIP('Select the Record')
                       SHEET,AT(4,4,150,172),USE(?CurrentTab)
                         TAB('&1) INTEG_2'),USE(?Tab:2)
                         END
                       END
                       BUTTON('&Close'),AT(52,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(105,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectCOUNTRY')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:COUNTRY.Open                                      ! File COUNTRY used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:COUNTRY,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,COU:INTEG_2)                          ! Add the sort order for COU:INTEG_2 for sort order 1
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort0:Locator.Init(,COU:COUNTRY,,BRW1)             ! Initialize the browse locator using  using key: COU:INTEG_2 , COU:COUNTRY
  BRW1.AddField(COU:COUNTRY,BRW1.Q.COU:COUNTRY)            ! Field COU:COUNTRY is a hot field or requires assignment from browse
  BRW1.AddField(COU:CURRENCY,BRW1.Q.COU:CURRENCY)          ! Field COU:CURRENCY is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('SelectCOUNTRY',QuickWindow)                ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:COUNTRY.Close
  END
  IF SELF.Opened
    INIMgr.Update('SelectCOUNTRY',QuickWindow)             ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1                                      ! Hide the select button when disabled
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Form CUSTOMER
!!! </summary>
UpdateCUSTOMER PROCEDURE 

CurrentTab           STRING(80)                            !
ActionMessage        CSTRING(40)                           !
History::CUS:Record  LIKE(CUS:RECORD),THREAD
QuickWindow          WINDOW('Form CUSTOMER'),AT(,,204,182),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('UpdateCUSTOMER'),SYSTEM
                       SHEET,AT(4,4,196,156),USE(?CurrentTab)
                         TAB('&1) General'),USE(?Tab:1)
                           PROMPT('CUST NO:'),AT(8,20),USE(?CUS:CUST_NO:Prompt),TRN
                           ENTRY(@n-14),AT(72,20,64,10),USE(CUS:CUST_NO)
                           PROMPT('CUSTOMER:'),AT(8,34),USE(?CUS:CUSTOMER:Prompt),TRN
                           ENTRY(@s25),AT(72,34,104,10),USE(CUS:CUSTOMER)
                           PROMPT('CONTACT FIRST:'),AT(8,48),USE(?CUS:CONTACT_FIRST:Prompt),TRN
                           ENTRY(@s15),AT(72,48,64,10),USE(CUS:CONTACT_FIRST)
                           PROMPT('CONTACT LAST:'),AT(8,62),USE(?CUS:CONTACT_LAST:Prompt),TRN
                           ENTRY(@s20),AT(72,62,84,10),USE(CUS:CONTACT_LAST)
                           PROMPT('PHONE NO:'),AT(8,76),USE(?CUS:PHONE_NO:Prompt),TRN
                           ENTRY(@s20),AT(72,76,84,10),USE(CUS:PHONE_NO)
                           PROMPT('ADDRESS LINE 1:'),AT(8,90),USE(?CUS:ADDRESS_LINE1:Prompt),TRN
                           ENTRY(@s30),AT(72,90,124,10),USE(CUS:ADDRESS_LINE1)
                           PROMPT('ADDRESS LINE 2:'),AT(8,104),USE(?CUS:ADDRESS_LINE2:Prompt),TRN
                           ENTRY(@s30),AT(72,104,124,10),USE(CUS:ADDRESS_LINE2)
                           PROMPT('CITY:'),AT(8,118),USE(?CUS:CITY:Prompt),TRN
                           ENTRY(@s25),AT(72,118,104,10),USE(CUS:CITY)
                           PROMPT('STATE PROVINCE:'),AT(8,132),USE(?CUS:STATE_PROVINCE:Prompt),TRN
                           ENTRY(@s15),AT(72,132,64,10),USE(CUS:STATE_PROVINCE)
                           PROMPT('COUNTRY:'),AT(8,146),USE(?CUS:COUNTRY:Prompt),TRN
                           ENTRY(@s15),AT(72,146,64,10),USE(CUS:COUNTRY)
                         END
                         TAB('&2) General (cont.)'),USE(?Tab:2)
                           PROMPT('POSTAL CODE:'),AT(8,20),USE(?CUS:POSTAL_CODE:Prompt),TRN
                           ENTRY(@s12),AT(72,20,52,10),USE(CUS:POSTAL_CODE)
                           PROMPT('ON HOLD:'),AT(8,34),USE(?CUS:ON_HOLD:Prompt),TRN
                           ENTRY(@s1),AT(72,34,40,10),USE(CUS:ON_HOLD)
                         END
                       END
                       BUTTON('&OK'),AT(45,164,49,14),USE(?OK),LEFT,ICON('WAOK.ICO'),DEFAULT,FLAT,MSG('Accept dat' & |
  'a and close the window'),TIP('Accept data and close the window')
                       BUTTON('&Cancel'),AT(98,164,49,14),USE(?Cancel),LEFT,ICON('WACANCEL.ICO'),FLAT,MSG('Cancel operation'), |
  TIP('Cancel operation')
                       BUTTON('&Help'),AT(151,164,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Record Will Be Changed'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateCUSTOMER')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?CUS:CUST_NO:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(CUS:Record,History::CUS:Record)
  SELF.AddHistoryField(?CUS:CUST_NO,1)
  SELF.AddHistoryField(?CUS:CUSTOMER,2)
  SELF.AddHistoryField(?CUS:CONTACT_FIRST,3)
  SELF.AddHistoryField(?CUS:CONTACT_LAST,4)
  SELF.AddHistoryField(?CUS:PHONE_NO,5)
  SELF.AddHistoryField(?CUS:ADDRESS_LINE1,6)
  SELF.AddHistoryField(?CUS:ADDRESS_LINE2,7)
  SELF.AddHistoryField(?CUS:CITY,8)
  SELF.AddHistoryField(?CUS:STATE_PROVINCE,9)
  SELF.AddHistoryField(?CUS:COUNTRY,10)
  SELF.AddHistoryField(?CUS:POSTAL_CODE,11)
  SELF.AddHistoryField(?CUS:ON_HOLD,12)
  SELF.AddUpdateFile(Access:CUSTOMER)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:COUNTRY.Open                                      ! File COUNTRY used by this procedure, so make sure it's RelationManager is open
  Relate:CUSTOMER.Open                                     ! File CUSTOMER used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:CUSTOMER
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF SELF.Request = ViewRecord                             ! Configure controls for View Only mode
    ?CUS:CUST_NO{PROP:ReadOnly} = True
    ?CUS:CUSTOMER{PROP:ReadOnly} = True
    ?CUS:CONTACT_FIRST{PROP:ReadOnly} = True
    ?CUS:CONTACT_LAST{PROP:ReadOnly} = True
    ?CUS:PHONE_NO{PROP:ReadOnly} = True
    ?CUS:ADDRESS_LINE1{PROP:ReadOnly} = True
    ?CUS:ADDRESS_LINE2{PROP:ReadOnly} = True
    ?CUS:CITY{PROP:ReadOnly} = True
    ?CUS:STATE_PROVINCE{PROP:ReadOnly} = True
    ?CUS:COUNTRY{PROP:ReadOnly} = True
    ?CUS:POSTAL_CODE{PROP:ReadOnly} = True
    ?CUS:ON_HOLD{PROP:ReadOnly} = True
  END
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdateCUSTOMER',QuickWindow)               ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:COUNTRY.Close
    Relate:CUSTOMER.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateCUSTOMER',QuickWindow)            ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    SelectCOUNTRY
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?CUS:COUNTRY
      COU:COUNTRY = CUS:COUNTRY
      IF Access:COUNTRY.TryFetch(COU:INTEG_2)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          CUS:COUNTRY = COU:COUNTRY
        ELSE
          SELECT(?CUS:COUNTRY)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:CUSTOMER.TryValidateField(10)              ! Attempt to validate CUS:COUNTRY in CUSTOMER
        SELECT(?CUS:COUNTRY)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?CUS:COUNTRY
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?CUS:COUNTRY{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Select a DEPARTMENT2 Record
!!! </summary>
SelectDEPARTMENT2 PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(DEPARTMENT2)
                       PROJECT(DEP1:DEPT_NO)
                       PROJECT(DEP1:DEPARTMENT)
                       PROJECT(DEP1:HEAD_DEPT)
                       PROJECT(DEP1:MNGR_NO)
                       PROJECT(DEP1:BUDGET)
                       PROJECT(DEP1:LOCATION)
                       PROJECT(DEP1:PHONE_NO)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
DEP1:DEPT_NO           LIKE(DEP1:DEPT_NO)             !List box control field - type derived from field
DEP1:DEPARTMENT        LIKE(DEP1:DEPARTMENT)          !List box control field - type derived from field
DEP1:HEAD_DEPT         LIKE(DEP1:HEAD_DEPT)           !List box control field - type derived from field
DEP1:MNGR_NO           LIKE(DEP1:MNGR_NO)             !List box control field - type derived from field
DEP1:BUDGET            LIKE(DEP1:BUDGET)              !List box control field - type derived from field
DEP1:LOCATION          LIKE(DEP1:LOCATION)            !List box control field - type derived from field
DEP1:PHONE_NO          LIKE(DEP1:PHONE_NO)            !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a DEPARTMENT2 Record'),AT(,,358,198),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('SelectDEPARTMENT2'),SYSTEM
                       LIST,AT(8,30,342,124),USE(?Browse:1),HVSCROLL,FORMAT('32L(2)|M~DEPT NO~L(2)@s3@80L(2)|M' & |
  '~DEPARTMENT~L(2)@s25@40L(2)|M~HEAD DEPT~L(2)@s3@36R(2)|M~MNGR NO~C(0)@n-7@76D(32)|M~' & |
  'BUDGET~C(0)@n-17.2@64L(2)|M~LOCATION~L(2)@s15@80L(2)|M~PHONE NO~L(2)@s20@'),FROM(Queue:Browse:1), |
  IMM,MSG('Browsing the DEPARTMENT2 file')
                       BUTTON('&Select'),AT(301,158,49,14),USE(?Select:2),LEFT,ICON('WASELECT.ICO'),FLAT,MSG('Select the Record'), |
  TIP('Select the Record')
                       SHEET,AT(4,4,350,172),USE(?CurrentTab)
                         TAB('&1) BUDGETX'),USE(?Tab:2)
                         END
                         TAB('&2) INTEG_31'),USE(?Tab:3)
                         END
                         TAB('&3) INTEG_17'),USE(?Tab:4)
                         END
                         TAB('&4) INTEG_16'),USE(?Tab:5)
                         END
                         TAB('&5) RDB_4'),USE(?Tab:6)
                         END
                       END
                       BUTTON('&Close'),AT(252,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(305,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort2:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 3
BRW1::Sort3:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 4
BRW1::Sort4:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 5
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectDEPARTMENT2')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('DEP1:DEPT_NO',DEP1:DEPT_NO)                        ! Added by: BrowseBox(ABC)
  BIND('DEP1:HEAD_DEPT',DEP1:HEAD_DEPT)                    ! Added by: BrowseBox(ABC)
  BIND('DEP1:MNGR_NO',DEP1:MNGR_NO)                        ! Added by: BrowseBox(ABC)
  BIND('DEP1:PHONE_NO',DEP1:PHONE_NO)                      ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:DEPARTMENT2.Open                                  ! File DEPARTMENT2 used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:DEPARTMENT2,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,DEP1:INTEG_31)                        ! Add the sort order for DEP1:INTEG_31 for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,DEP1:MNGR_NO,,BRW1)            ! Initialize the browse locator using  using key: DEP1:INTEG_31 , DEP1:MNGR_NO
  BRW1.AddSortOrder(,DEP1:INTEG_17)                        ! Add the sort order for DEP1:INTEG_17 for sort order 2
  BRW1.AddLocator(BRW1::Sort2:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort2:Locator.Init(,DEP1:HEAD_DEPT,,BRW1)          ! Initialize the browse locator using  using key: DEP1:INTEG_17 , DEP1:HEAD_DEPT
  BRW1.AddSortOrder(,DEP1:INTEG_16)                        ! Add the sort order for DEP1:INTEG_16 for sort order 3
  BRW1.AddLocator(BRW1::Sort3:Locator)                     ! Browse has a locator for sort order 3
  BRW1::Sort3:Locator.Init(,DEP1:DEPT_NO,,BRW1)            ! Initialize the browse locator using  using key: DEP1:INTEG_16 , DEP1:DEPT_NO
  BRW1.AddSortOrder(,DEP1:RDB_4)                           ! Add the sort order for DEP1:RDB_4 for sort order 4
  BRW1.AddLocator(BRW1::Sort4:Locator)                     ! Browse has a locator for sort order 4
  BRW1::Sort4:Locator.Init(,DEP1:DEPARTMENT,,BRW1)         ! Initialize the browse locator using  using key: DEP1:RDB_4 , DEP1:DEPARTMENT
  BRW1.AddSortOrder(,DEP1:BUDGETX)                         ! Add the sort order for DEP1:BUDGETX for sort order 5
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 5
  BRW1::Sort0:Locator.Init(,DEP1:BUDGET,,BRW1)             ! Initialize the browse locator using  using key: DEP1:BUDGETX , DEP1:BUDGET
  BRW1.AddField(DEP1:DEPT_NO,BRW1.Q.DEP1:DEPT_NO)          ! Field DEP1:DEPT_NO is a hot field or requires assignment from browse
  BRW1.AddField(DEP1:DEPARTMENT,BRW1.Q.DEP1:DEPARTMENT)    ! Field DEP1:DEPARTMENT is a hot field or requires assignment from browse
  BRW1.AddField(DEP1:HEAD_DEPT,BRW1.Q.DEP1:HEAD_DEPT)      ! Field DEP1:HEAD_DEPT is a hot field or requires assignment from browse
  BRW1.AddField(DEP1:MNGR_NO,BRW1.Q.DEP1:MNGR_NO)          ! Field DEP1:MNGR_NO is a hot field or requires assignment from browse
  BRW1.AddField(DEP1:BUDGET,BRW1.Q.DEP1:BUDGET)            ! Field DEP1:BUDGET is a hot field or requires assignment from browse
  BRW1.AddField(DEP1:LOCATION,BRW1.Q.DEP1:LOCATION)        ! Field DEP1:LOCATION is a hot field or requires assignment from browse
  BRW1.AddField(DEP1:PHONE_NO,BRW1.Q.DEP1:PHONE_NO)        ! Field DEP1:PHONE_NO is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('SelectDEPARTMENT2',QuickWindow)            ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:DEPARTMENT2.Close
  END
  IF SELF.Opened
    INIMgr.Update('SelectDEPARTMENT2',QuickWindow)         ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1                                      ! Hide the select button when disabled
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSIF CHOICE(?CurrentTab) = 4
    RETURN SELF.SetSort(3,Force)
  ELSIF CHOICE(?CurrentTab) = 5
    RETURN SELF.SetSort(4,Force)
  ELSE
    RETURN SELF.SetSort(5,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Select a EMPLOYEE Record
!!! </summary>
SelectEMPLOYEE PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(EMPLOYEE)
                       PROJECT(EMP:EMP_NO)
                       PROJECT(EMP:FIRST_NAME)
                       PROJECT(EMP:LAST_NAME)
                       PROJECT(EMP:PHONE_EXT)
                       PROJECT(EMP:HIRE_DATE_DATE)
                       PROJECT(EMP:HIRE_DATE_TIME)
                       PROJECT(EMP:DEPT_NO)
                       PROJECT(EMP:JOB_CODE)
                       PROJECT(EMP:JOB_GRADE)
                       PROJECT(EMP:JOB_COUNTRY)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
EMP:EMP_NO             LIKE(EMP:EMP_NO)               !List box control field - type derived from field
EMP:FIRST_NAME         LIKE(EMP:FIRST_NAME)           !List box control field - type derived from field
EMP:LAST_NAME          LIKE(EMP:LAST_NAME)            !List box control field - type derived from field
EMP:PHONE_EXT          LIKE(EMP:PHONE_EXT)            !List box control field - type derived from field
EMP:HIRE_DATE_DATE     LIKE(EMP:HIRE_DATE_DATE)       !List box control field - type derived from field
EMP:HIRE_DATE_TIME     LIKE(EMP:HIRE_DATE_TIME)       !List box control field - type derived from field
EMP:DEPT_NO            LIKE(EMP:DEPT_NO)              !List box control field - type derived from field
EMP:JOB_CODE           LIKE(EMP:JOB_CODE)             !List box control field - type derived from field
EMP:JOB_GRADE          LIKE(EMP:JOB_GRADE)            !List box control field - type derived from field
EMP:JOB_COUNTRY        LIKE(EMP:JOB_COUNTRY)          !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a EMPLOYEE Record'),AT(,,358,198),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('SelectEMPLOYEE'),SYSTEM
                       LIST,AT(8,30,342,124),USE(?Browse:1),HVSCROLL,FORMAT('36R(2)|M~EMP NO~C(0)@n-7@64L(2)|M' & |
  '~FIRST NAME~L(2)@s15@80L(2)|M~LAST NAME~L(2)@s20@40L(2)|M~PHONE EXT~L(2)@s4@80R(2)|M' & |
  '~HIRE DATE DATE~C(0)@d17@80R(2)|M~HIRE DATE TIME~C(0)@t7@32L(2)|M~DEPT NO~L(2)@s3@36' & |
  'L(2)|M~JOB CODE~L(2)@s5@40R(2)|M~JOB GRADE~C(0)@n-7@'),FROM(Queue:Browse:1),IMM,MSG('Browsing t' & |
  'he EMPLOYEE file')
                       BUTTON('&Select'),AT(301,158,49,14),USE(?Select:2),LEFT,ICON('WASELECT.ICO'),FLAT,MSG('Select the Record'), |
  TIP('Select the Record')
                       SHEET,AT(4,4,350,172),USE(?CurrentTab)
                         TAB('&1) NAMEX'),USE(?Tab:2)
                         END
                         TAB('&2) INTEG_28'),USE(?Tab:3)
                         END
                         TAB('&3) INTEG_29'),USE(?Tab:4)
                         END
                         TAB('&4) INTEG_27'),USE(?Tab:5)
                         END
                       END
                       BUTTON('&Close'),AT(252,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(305,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort2:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 3
BRW1::Sort3:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 4
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectEMPLOYEE')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('EMP:EMP_NO',EMP:EMP_NO)                            ! Added by: BrowseBox(ABC)
  BIND('EMP:FIRST_NAME',EMP:FIRST_NAME)                    ! Added by: BrowseBox(ABC)
  BIND('EMP:LAST_NAME',EMP:LAST_NAME)                      ! Added by: BrowseBox(ABC)
  BIND('EMP:PHONE_EXT',EMP:PHONE_EXT)                      ! Added by: BrowseBox(ABC)
  BIND('EMP:DEPT_NO',EMP:DEPT_NO)                          ! Added by: BrowseBox(ABC)
  BIND('EMP:JOB_CODE',EMP:JOB_CODE)                        ! Added by: BrowseBox(ABC)
  BIND('EMP:JOB_GRADE',EMP:JOB_GRADE)                      ! Added by: BrowseBox(ABC)
  BIND('EMP:JOB_COUNTRY',EMP:JOB_COUNTRY)                  ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:EMPLOYEE.Open                                     ! File EMPLOYEE used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:EMPLOYEE,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,EMP:INTEG_28)                         ! Add the sort order for EMP:INTEG_28 for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,EMP:DEPT_NO,,BRW1)             ! Initialize the browse locator using  using key: EMP:INTEG_28 , EMP:DEPT_NO
  BRW1.AddSortOrder(,EMP:INTEG_29)                         ! Add the sort order for EMP:INTEG_29 for sort order 2
  BRW1.AddLocator(BRW1::Sort2:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort2:Locator.Init(,EMP:JOB_CODE,,BRW1)            ! Initialize the browse locator using  using key: EMP:INTEG_29 , EMP:JOB_CODE
  BRW1.AddSortOrder(,EMP:INTEG_27)                         ! Add the sort order for EMP:INTEG_27 for sort order 3
  BRW1.AddLocator(BRW1::Sort3:Locator)                     ! Browse has a locator for sort order 3
  BRW1::Sort3:Locator.Init(,EMP:EMP_NO,,BRW1)              ! Initialize the browse locator using  using key: EMP:INTEG_27 , EMP:EMP_NO
  BRW1.AddSortOrder(,EMP:NAMEX)                            ! Add the sort order for EMP:NAMEX for sort order 4
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 4
  BRW1::Sort0:Locator.Init(,EMP:LAST_NAME,,BRW1)           ! Initialize the browse locator using  using key: EMP:NAMEX , EMP:LAST_NAME
  BRW1.AddField(EMP:EMP_NO,BRW1.Q.EMP:EMP_NO)              ! Field EMP:EMP_NO is a hot field or requires assignment from browse
  BRW1.AddField(EMP:FIRST_NAME,BRW1.Q.EMP:FIRST_NAME)      ! Field EMP:FIRST_NAME is a hot field or requires assignment from browse
  BRW1.AddField(EMP:LAST_NAME,BRW1.Q.EMP:LAST_NAME)        ! Field EMP:LAST_NAME is a hot field or requires assignment from browse
  BRW1.AddField(EMP:PHONE_EXT,BRW1.Q.EMP:PHONE_EXT)        ! Field EMP:PHONE_EXT is a hot field or requires assignment from browse
  BRW1.AddField(EMP:HIRE_DATE_DATE,BRW1.Q.EMP:HIRE_DATE_DATE) ! Field EMP:HIRE_DATE_DATE is a hot field or requires assignment from browse
  BRW1.AddField(EMP:HIRE_DATE_TIME,BRW1.Q.EMP:HIRE_DATE_TIME) ! Field EMP:HIRE_DATE_TIME is a hot field or requires assignment from browse
  BRW1.AddField(EMP:DEPT_NO,BRW1.Q.EMP:DEPT_NO)            ! Field EMP:DEPT_NO is a hot field or requires assignment from browse
  BRW1.AddField(EMP:JOB_CODE,BRW1.Q.EMP:JOB_CODE)          ! Field EMP:JOB_CODE is a hot field or requires assignment from browse
  BRW1.AddField(EMP:JOB_GRADE,BRW1.Q.EMP:JOB_GRADE)        ! Field EMP:JOB_GRADE is a hot field or requires assignment from browse
  BRW1.AddField(EMP:JOB_COUNTRY,BRW1.Q.EMP:JOB_COUNTRY)    ! Field EMP:JOB_COUNTRY is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('SelectEMPLOYEE',QuickWindow)               ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:EMPLOYEE.Close
  END
  IF SELF.Opened
    INIMgr.Update('SelectEMPLOYEE',QuickWindow)            ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1                                      ! Hide the select button when disabled
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSIF CHOICE(?CurrentTab) = 4
    RETURN SELF.SetSort(3,Force)
  ELSE
    RETURN SELF.SetSort(4,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Form DEPARTMENT
!!! </summary>
UpdateDEPARTMENT PROCEDURE 

CurrentTab           STRING(80)                            !
ActionMessage        CSTRING(40)                           !
History::DEP:Record  LIKE(DEP:RECORD),THREAD
QuickWindow          WINDOW('Form DEPARTMENT'),AT(,,173,140),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('UpdateDEPARTMENT'),SYSTEM
                       SHEET,AT(4,4,165,114),USE(?CurrentTab)
                         TAB('&1) General'),USE(?Tab:1)
                           PROMPT('DEPT NO:'),AT(8,20),USE(?DEP:DEPT_NO:Prompt),TRN
                           ENTRY(@s3),AT(61,20,40,10),USE(DEP:DEPT_NO)
                           PROMPT('DEPARTMENT:'),AT(8,34),USE(?DEP:DEPARTMENT:Prompt),TRN
                           ENTRY(@s25),AT(61,34,104,10),USE(DEP:DEPARTMENT)
                           PROMPT('HEAD DEPT:'),AT(8,48),USE(?DEP:HEAD_DEPT:Prompt),TRN
                           ENTRY(@s3),AT(61,48,40,10),USE(DEP:HEAD_DEPT)
                           PROMPT('MNGR NO:'),AT(8,62),USE(?DEP:MNGR_NO:Prompt),TRN
                           ENTRY(@n-7),AT(61,62,40,10),USE(DEP:MNGR_NO)
                           PROMPT('BUDGET:'),AT(8,76),USE(?DEP:BUDGET:Prompt),TRN
                           ENTRY(@n-17.2),AT(61,76,76,10),USE(DEP:BUDGET)
                           PROMPT('LOCATION:'),AT(8,90),USE(?DEP:LOCATION:Prompt),TRN
                           ENTRY(@s15),AT(61,90,64,10),USE(DEP:LOCATION)
                           PROMPT('PHONE NO:'),AT(8,104),USE(?DEP:PHONE_NO:Prompt),TRN
                           ENTRY(@s20),AT(61,104,84,10),USE(DEP:PHONE_NO)
                         END
                       END
                       BUTTON('&OK'),AT(14,122,49,14),USE(?OK),LEFT,ICON('WAOK.ICO'),DEFAULT,FLAT,MSG('Accept dat' & |
  'a and close the window'),TIP('Accept data and close the window')
                       BUTTON('&Cancel'),AT(67,122,49,14),USE(?Cancel),LEFT,ICON('WACANCEL.ICO'),FLAT,MSG('Cancel operation'), |
  TIP('Cancel operation')
                       BUTTON('&Help'),AT(120,122,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Record Will Be Changed'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateDEPARTMENT')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?DEP:DEPT_NO:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(DEP:Record,History::DEP:Record)
  SELF.AddHistoryField(?DEP:DEPT_NO,1)
  SELF.AddHistoryField(?DEP:DEPARTMENT,2)
  SELF.AddHistoryField(?DEP:HEAD_DEPT,3)
  SELF.AddHistoryField(?DEP:MNGR_NO,4)
  SELF.AddHistoryField(?DEP:BUDGET,5)
  SELF.AddHistoryField(?DEP:LOCATION,6)
  SELF.AddHistoryField(?DEP:PHONE_NO,7)
  SELF.AddUpdateFile(Access:DEPARTMENT)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:DEPARTMENT.Open                                   ! File DEPARTMENT used by this procedure, so make sure it's RelationManager is open
  Relate:DEPARTMENT2.Open                                  ! File DEPARTMENT2 used by this procedure, so make sure it's RelationManager is open
  Relate:EMPLOYEE.Open                                     ! File EMPLOYEE used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:DEPARTMENT
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF SELF.Request = ViewRecord                             ! Configure controls for View Only mode
    ?DEP:DEPT_NO{PROP:ReadOnly} = True
    ?DEP:DEPARTMENT{PROP:ReadOnly} = True
    ?DEP:HEAD_DEPT{PROP:ReadOnly} = True
    ?DEP:MNGR_NO{PROP:ReadOnly} = True
    ?DEP:BUDGET{PROP:ReadOnly} = True
    ?DEP:LOCATION{PROP:ReadOnly} = True
    ?DEP:PHONE_NO{PROP:ReadOnly} = True
  END
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdateDEPARTMENT',QuickWindow)             ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:DEPARTMENT.Close
    Relate:DEPARTMENT2.Close
    Relate:EMPLOYEE.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateDEPARTMENT',QuickWindow)          ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    EXECUTE Number
      SelectDEPARTMENT2
      SelectEMPLOYEE
    END
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?DEP:HEAD_DEPT
      DEP1:DEPT_NO = DEP:HEAD_DEPT
      IF Access:DEPARTMENT2.TryFetch(DEP1:INTEG_16)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          DEP:HEAD_DEPT = DEP1:DEPT_NO
        ELSE
          SELECT(?DEP:HEAD_DEPT)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:DEPARTMENT.TryValidateField(3)             ! Attempt to validate DEP:HEAD_DEPT in DEPARTMENT
        SELECT(?DEP:HEAD_DEPT)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?DEP:HEAD_DEPT
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?DEP:HEAD_DEPT{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?DEP:MNGR_NO
      EMP:DEPT_NO = DEP:MNGR_NO
      IF Access:EMPLOYEE.TryFetch(EMP:INTEG_28)
        IF SELF.Run(2,SelectRecord) = RequestCompleted
          DEP:MNGR_NO = EMP:DEPT_NO
        ELSE
          SELECT(?DEP:MNGR_NO)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:DEPARTMENT.TryValidateField(4)             ! Attempt to validate DEP:MNGR_NO in DEPARTMENT
        SELECT(?DEP:MNGR_NO)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?DEP:MNGR_NO
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?DEP:MNGR_NO{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

