

   MEMBER('Firebird.clw')                                  ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('FIREBIRD004.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('FIREBIRD002.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('FIREBIRD003.INC'),ONCE        !Req'd for module callout resolution
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! Select a CUSTOMER Record
!!! </summary>
SelectCUSTOMER PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(CUSTOMER)
                       PROJECT(CUS:CUST_NO)
                       PROJECT(CUS:CUSTOMER)
                       PROJECT(CUS:CONTACT_FIRST)
                       PROJECT(CUS:CONTACT_LAST)
                       PROJECT(CUS:PHONE_NO)
                       PROJECT(CUS:ADDRESS_LINE1)
                       PROJECT(CUS:ADDRESS_LINE2)
                       PROJECT(CUS:CITY)
                       PROJECT(CUS:STATE_PROVINCE)
                       PROJECT(CUS:COUNTRY)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
CUS:CUST_NO            LIKE(CUS:CUST_NO)              !List box control field - type derived from field
CUS:CUSTOMER           LIKE(CUS:CUSTOMER)             !List box control field - type derived from field
CUS:CONTACT_FIRST      LIKE(CUS:CONTACT_FIRST)        !List box control field - type derived from field
CUS:CONTACT_LAST       LIKE(CUS:CONTACT_LAST)         !List box control field - type derived from field
CUS:PHONE_NO           LIKE(CUS:PHONE_NO)             !List box control field - type derived from field
CUS:ADDRESS_LINE1      LIKE(CUS:ADDRESS_LINE1)        !List box control field - type derived from field
CUS:ADDRESS_LINE2      LIKE(CUS:ADDRESS_LINE2)        !List box control field - type derived from field
CUS:CITY               LIKE(CUS:CITY)                 !List box control field - type derived from field
CUS:STATE_PROVINCE     LIKE(CUS:STATE_PROVINCE)       !List box control field - type derived from field
CUS:COUNTRY            LIKE(CUS:COUNTRY)              !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a CUSTOMER Record'),AT(,,358,198),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('SelectCUSTOMER'),SYSTEM
                       LIST,AT(8,30,342,124),USE(?Browse:1),HVSCROLL,FORMAT('64R(2)|M~CUST NO~C(0)@n-14@80L(2)' & |
  '|M~CUSTOMER~L(2)@s25@64L(2)|M~CONTACT FIRST~L(2)@s15@80L(2)|M~CONTACT LAST~L(2)@s20@' & |
  '80L(2)|M~PHONE NO~L(2)@s20@80L(2)|M~ADDRESS LINE 1~L(2)@s30@80L(2)|M~ADDRESS LINE 2~' & |
  'L(2)@s30@80L(2)|M~CITY~L(2)@s25@64L(2)|M~STATE PROVINCE~L(2)@s15@'),FROM(Queue:Browse:1), |
  IMM,MSG('Browsing the CUSTOMER file')
                       BUTTON('&Select'),AT(301,158,49,14),USE(?Select:2),LEFT,ICON('WASELECT.ICO'),FLAT,MSG('Select the Record'), |
  TIP('Select the Record')
                       SHEET,AT(4,4,350,172),USE(?CurrentTab)
                         TAB('&1) CUSTNAMEX'),USE(?Tab:2)
                         END
                         TAB('&2) CUSTREGION'),USE(?Tab:3)
                         END
                         TAB('&3) INTEG_61'),USE(?Tab:4)
                         END
                         TAB('&4) INTEG_60'),USE(?Tab:5)
                         END
                       END
                       BUTTON('&Close'),AT(252,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(305,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort2:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 3
BRW1::Sort3:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 4
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectCUSTOMER')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('CUS:CUST_NO',CUS:CUST_NO)                          ! Added by: BrowseBox(ABC)
  BIND('CUS:CONTACT_FIRST',CUS:CONTACT_FIRST)              ! Added by: BrowseBox(ABC)
  BIND('CUS:CONTACT_LAST',CUS:CONTACT_LAST)                ! Added by: BrowseBox(ABC)
  BIND('CUS:PHONE_NO',CUS:PHONE_NO)                        ! Added by: BrowseBox(ABC)
  BIND('CUS:ADDRESS_LINE1',CUS:ADDRESS_LINE1)              ! Added by: BrowseBox(ABC)
  BIND('CUS:ADDRESS_LINE2',CUS:ADDRESS_LINE2)              ! Added by: BrowseBox(ABC)
  BIND('CUS:STATE_PROVINCE',CUS:STATE_PROVINCE)            ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:CUSTOMER.Open                                     ! File CUSTOMER used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:CUSTOMER,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,CUS:CUSTREGION)                       ! Add the sort order for CUS:CUSTREGION for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,CUS:COUNTRY,,BRW1)             ! Initialize the browse locator using  using key: CUS:CUSTREGION , CUS:COUNTRY
  BRW1.AddSortOrder(,CUS:INTEG_61)                         ! Add the sort order for CUS:INTEG_61 for sort order 2
  BRW1.AddLocator(BRW1::Sort2:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort2:Locator.Init(,CUS:COUNTRY,,BRW1)             ! Initialize the browse locator using  using key: CUS:INTEG_61 , CUS:COUNTRY
  BRW1.AddSortOrder(,CUS:INTEG_60)                         ! Add the sort order for CUS:INTEG_60 for sort order 3
  BRW1.AddLocator(BRW1::Sort3:Locator)                     ! Browse has a locator for sort order 3
  BRW1::Sort3:Locator.Init(,CUS:CUST_NO,,BRW1)             ! Initialize the browse locator using  using key: CUS:INTEG_60 , CUS:CUST_NO
  BRW1.AddSortOrder(,CUS:CUSTNAMEX)                        ! Add the sort order for CUS:CUSTNAMEX for sort order 4
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 4
  BRW1::Sort0:Locator.Init(,CUS:CUSTOMER,,BRW1)            ! Initialize the browse locator using  using key: CUS:CUSTNAMEX , CUS:CUSTOMER
  BRW1.AddField(CUS:CUST_NO,BRW1.Q.CUS:CUST_NO)            ! Field CUS:CUST_NO is a hot field or requires assignment from browse
  BRW1.AddField(CUS:CUSTOMER,BRW1.Q.CUS:CUSTOMER)          ! Field CUS:CUSTOMER is a hot field or requires assignment from browse
  BRW1.AddField(CUS:CONTACT_FIRST,BRW1.Q.CUS:CONTACT_FIRST) ! Field CUS:CONTACT_FIRST is a hot field or requires assignment from browse
  BRW1.AddField(CUS:CONTACT_LAST,BRW1.Q.CUS:CONTACT_LAST)  ! Field CUS:CONTACT_LAST is a hot field or requires assignment from browse
  BRW1.AddField(CUS:PHONE_NO,BRW1.Q.CUS:PHONE_NO)          ! Field CUS:PHONE_NO is a hot field or requires assignment from browse
  BRW1.AddField(CUS:ADDRESS_LINE1,BRW1.Q.CUS:ADDRESS_LINE1) ! Field CUS:ADDRESS_LINE1 is a hot field or requires assignment from browse
  BRW1.AddField(CUS:ADDRESS_LINE2,BRW1.Q.CUS:ADDRESS_LINE2) ! Field CUS:ADDRESS_LINE2 is a hot field or requires assignment from browse
  BRW1.AddField(CUS:CITY,BRW1.Q.CUS:CITY)                  ! Field CUS:CITY is a hot field or requires assignment from browse
  BRW1.AddField(CUS:STATE_PROVINCE,BRW1.Q.CUS:STATE_PROVINCE) ! Field CUS:STATE_PROVINCE is a hot field or requires assignment from browse
  BRW1.AddField(CUS:COUNTRY,BRW1.Q.CUS:COUNTRY)            ! Field CUS:COUNTRY is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('SelectCUSTOMER',QuickWindow)               ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:CUSTOMER.Close
  END
  IF SELF.Opened
    INIMgr.Update('SelectCUSTOMER',QuickWindow)            ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1                                      ! Hide the select button when disabled
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSIF CHOICE(?CurrentTab) = 4
    RETURN SELF.SetSort(3,Force)
  ELSE
    RETURN SELF.SetSort(4,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Form SALES
!!! </summary>
UpdateSALES PROCEDURE 

CurrentTab           STRING(80)                            !
ActionMessage        CSTRING(40)                           !
History::SAL2:Record LIKE(SAL2:RECORD),THREAD
QuickWindow          WINDOW('Form SALES'),AT(,,192,182),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT),RESIZE, |
  CENTER,GRAY,IMM,MDI,HLP('UpdateSALES'),SYSTEM
                       SHEET,AT(4,4,184,156),USE(?CurrentTab)
                         TAB('&1) General'),USE(?Tab:1)
                           PROMPT('PO NUMBER:'),AT(8,20),USE(?SAL2:PO_NUMBER:Prompt),TRN
                           ENTRY(@s8),AT(80,20,40,10),USE(SAL2:PO_NUMBER)
                           PROMPT('CUST NO:'),AT(8,34),USE(?SAL2:CUST_NO:Prompt),TRN
                           ENTRY(@n-14),AT(80,34,64,10),USE(SAL2:CUST_NO)
                           PROMPT('SALES REP:'),AT(8,48),USE(?SAL2:SALES_REP:Prompt),TRN
                           ENTRY(@n-7),AT(80,48,40,10),USE(SAL2:SALES_REP)
                           PROMPT('ORDER STATUS:'),AT(8,62),USE(?SAL2:ORDER_STATUS:Prompt),TRN
                           ENTRY(@s7),AT(80,62,40,10),USE(SAL2:ORDER_STATUS)
                           PROMPT('ORDER DATE DATE:'),AT(8,76),USE(?SAL2:ORDER_DATE_DATE:Prompt),TRN
                           ENTRY(@d17),AT(80,76,104,10),USE(SAL2:ORDER_DATE_DATE)
                           PROMPT('ORDER DATE TIME:'),AT(8,90),USE(?SAL2:ORDER_DATE_TIME:Prompt),TRN
                           ENTRY(@t7),AT(80,90,104,10),USE(SAL2:ORDER_DATE_TIME)
                           PROMPT('SHIP DATE DATE:'),AT(8,104),USE(?SAL2:SHIP_DATE_DATE:Prompt),TRN
                           ENTRY(@d17),AT(80,104,104,10),USE(SAL2:SHIP_DATE_DATE)
                           PROMPT('SHIP DATE TIME:'),AT(8,118),USE(?SAL2:SHIP_DATE_TIME:Prompt),TRN
                           ENTRY(@t7),AT(80,118,104,10),USE(SAL2:SHIP_DATE_TIME)
                           PROMPT('DATE NEEDED DATE:'),AT(8,132),USE(?SAL2:DATE_NEEDED_DATE:Prompt),TRN
                           ENTRY(@d17),AT(80,132,104,10),USE(SAL2:DATE_NEEDED_DATE)
                           PROMPT('DATE NEEDED TIME:'),AT(8,146),USE(?SAL2:DATE_NEEDED_TIME:Prompt),TRN
                           ENTRY(@t7),AT(80,146,104,10),USE(SAL2:DATE_NEEDED_TIME)
                         END
                         TAB('&2) General (cont.)'),USE(?Tab:2)
                           PROMPT('PAID:'),AT(8,20),USE(?SAL2:PAID:Prompt),TRN
                           ENTRY(@s1),AT(80,20,40,10),USE(SAL2:PAID)
                           PROMPT('QTY ORDERED:'),AT(8,34),USE(?SAL2:QTY_ORDERED:Prompt),TRN
                           ENTRY(@n-14),AT(80,34,64,10),USE(SAL2:QTY_ORDERED)
                           PROMPT('TOTAL VALUE:'),AT(8,48),USE(?SAL2:TOTAL_VALUE:Prompt),TRN
                           ENTRY(@n-13.2),AT(80,48,60,10),USE(SAL2:TOTAL_VALUE)
                           PROMPT('DISCOUNT:'),AT(8,62),USE(?SAL2:DISCOUNT:Prompt),TRN
                           ENTRY(@n10.2),AT(80,62,44,10),USE(SAL2:DISCOUNT)
                           PROMPT('ITEM TYPE:'),AT(8,76),USE(?SAL2:ITEM_TYPE:Prompt),TRN
                           ENTRY(@s12),AT(80,76,52,10),USE(SAL2:ITEM_TYPE)
                           PROMPT('AGED:'),AT(8,90),USE(?SAL2:AGED:Prompt),TRN
                           ENTRY(@n-22.9),AT(80,90,96,10),USE(SAL2:AGED)
                         END
                       END
                       BUTTON('&OK'),AT(33,164,49,14),USE(?OK),LEFT,ICON('WAOK.ICO'),DEFAULT,FLAT,MSG('Accept dat' & |
  'a and close the window'),TIP('Accept data and close the window')
                       BUTTON('&Cancel'),AT(86,164,49,14),USE(?Cancel),LEFT,ICON('WACANCEL.ICO'),FLAT,MSG('Cancel operation'), |
  TIP('Cancel operation')
                       BUTTON('&Help'),AT(139,164,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Record Will Be Changed'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateSALES')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?SAL2:PO_NUMBER:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(SAL2:Record,History::SAL2:Record)
  SELF.AddHistoryField(?SAL2:PO_NUMBER,1)
  SELF.AddHistoryField(?SAL2:CUST_NO,2)
  SELF.AddHistoryField(?SAL2:SALES_REP,3)
  SELF.AddHistoryField(?SAL2:ORDER_STATUS,4)
  SELF.AddHistoryField(?SAL2:ORDER_DATE_DATE,7)
  SELF.AddHistoryField(?SAL2:ORDER_DATE_TIME,8)
  SELF.AddHistoryField(?SAL2:SHIP_DATE_DATE,11)
  SELF.AddHistoryField(?SAL2:SHIP_DATE_TIME,12)
  SELF.AddHistoryField(?SAL2:DATE_NEEDED_DATE,15)
  SELF.AddHistoryField(?SAL2:DATE_NEEDED_TIME,16)
  SELF.AddHistoryField(?SAL2:PAID,17)
  SELF.AddHistoryField(?SAL2:QTY_ORDERED,18)
  SELF.AddHistoryField(?SAL2:TOTAL_VALUE,19)
  SELF.AddHistoryField(?SAL2:DISCOUNT,20)
  SELF.AddHistoryField(?SAL2:ITEM_TYPE,21)
  SELF.AddHistoryField(?SAL2:AGED,22)
  SELF.AddUpdateFile(Access:SALES)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:CUSTOMER.Open                                     ! File CUSTOMER used by this procedure, so make sure it's RelationManager is open
  Relate:EMPLOYEE.Open                                     ! File EMPLOYEE used by this procedure, so make sure it's RelationManager is open
  Relate:SALES.Open                                        ! File SALES used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:SALES
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF SELF.Request = ViewRecord                             ! Configure controls for View Only mode
    ?SAL2:PO_NUMBER{PROP:ReadOnly} = True
    ?SAL2:CUST_NO{PROP:ReadOnly} = True
    ?SAL2:SALES_REP{PROP:ReadOnly} = True
    ?SAL2:ORDER_STATUS{PROP:ReadOnly} = True
    ?SAL2:ORDER_DATE_DATE{PROP:ReadOnly} = True
    ?SAL2:ORDER_DATE_TIME{PROP:ReadOnly} = True
    ?SAL2:SHIP_DATE_DATE{PROP:ReadOnly} = True
    ?SAL2:SHIP_DATE_TIME{PROP:ReadOnly} = True
    ?SAL2:DATE_NEEDED_DATE{PROP:ReadOnly} = True
    ?SAL2:DATE_NEEDED_TIME{PROP:ReadOnly} = True
    ?SAL2:PAID{PROP:ReadOnly} = True
    ?SAL2:QTY_ORDERED{PROP:ReadOnly} = True
    ?SAL2:TOTAL_VALUE{PROP:ReadOnly} = True
    ?SAL2:DISCOUNT{PROP:ReadOnly} = True
    ?SAL2:ITEM_TYPE{PROP:ReadOnly} = True
    ?SAL2:AGED{PROP:ReadOnly} = True
  END
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdateSALES',QuickWindow)                  ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:CUSTOMER.Close
    Relate:EMPLOYEE.Close
    Relate:SALES.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateSALES',QuickWindow)               ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    EXECUTE Number
      SelectCUSTOMER
      SelectEMPLOYEE
    END
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?SAL2:CUST_NO
      CUS:CUST_NO = SAL2:CUST_NO
      IF Access:CUSTOMER.TryFetch(CUS:INTEG_60)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          SAL2:CUST_NO = CUS:CUST_NO
        ELSE
          SELECT(?SAL2:CUST_NO)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:SALES.TryValidateField(2)                  ! Attempt to validate SAL2:CUST_NO in SALES
        SELECT(?SAL2:CUST_NO)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?SAL2:CUST_NO
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?SAL2:CUST_NO{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?SAL2:SALES_REP
      EMP:EMP_NO = SAL2:SALES_REP
      IF Access:EMPLOYEE.TryFetch(EMP:INTEG_27)
        IF SELF.Run(2,SelectRecord) = RequestCompleted
          SAL2:SALES_REP = EMP:EMP_NO
        ELSE
          SELECT(?SAL2:SALES_REP)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:SALES.TryValidateField(3)                  ! Attempt to validate SAL2:SALES_REP in SALES
        SELECT(?SAL2:SALES_REP)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?SAL2:SALES_REP
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?SAL2:SALES_REP{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Form DEPARTMENT2
!!! </summary>
UpdateDEPARTMENT2 PROCEDURE 

CurrentTab           STRING(80)                            !
ActionMessage        CSTRING(40)                           !
History::DEP1:Record LIKE(DEP1:RECORD),THREAD
QuickWindow          WINDOW('Form DEPARTMENT2'),AT(,,173,140),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('UpdateDEPARTMENT2'),SYSTEM
                       SHEET,AT(4,4,165,114),USE(?CurrentTab)
                         TAB('&1) General'),USE(?Tab:1)
                           PROMPT('DEPT NO:'),AT(8,20),USE(?DEP:DEPT_NO:Prompt),TRN
                           ENTRY(@s3),AT(61,20,40,10),USE(DEP1:DEPT_NO)
                           PROMPT('DEPARTMENT:'),AT(8,34),USE(?DEP:DEPARTMENT:Prompt),TRN
                           ENTRY(@s25),AT(61,34,104,10),USE(DEP1:DEPARTMENT)
                           PROMPT('HEAD DEPT:'),AT(8,48),USE(?DEP:HEAD_DEPT:Prompt),TRN
                           ENTRY(@s3),AT(61,48,40,10),USE(DEP1:HEAD_DEPT)
                           PROMPT('MNGR NO:'),AT(8,62),USE(?DEP:MNGR_NO:Prompt),TRN
                           ENTRY(@n-7),AT(61,62,40,10),USE(DEP1:MNGR_NO)
                           PROMPT('BUDGET:'),AT(8,76),USE(?DEP:BUDGET:Prompt),TRN
                           ENTRY(@n-17.2),AT(61,76,76,10),USE(DEP1:BUDGET)
                           PROMPT('LOCATION:'),AT(8,90),USE(?DEP:LOCATION:Prompt),TRN
                           ENTRY(@s15),AT(61,90,64,10),USE(DEP1:LOCATION)
                           PROMPT('PHONE NO:'),AT(8,104),USE(?DEP:PHONE_NO:Prompt),TRN
                           ENTRY(@s20),AT(61,104,84,10),USE(DEP1:PHONE_NO)
                         END
                       END
                       BUTTON('&OK'),AT(14,122,49,14),USE(?OK),LEFT,ICON('WAOK.ICO'),DEFAULT,FLAT,MSG('Accept dat' & |
  'a and close the window'),TIP('Accept data and close the window')
                       BUTTON('&Cancel'),AT(67,122,49,14),USE(?Cancel),LEFT,ICON('WACANCEL.ICO'),FLAT,MSG('Cancel operation'), |
  TIP('Cancel operation')
                       BUTTON('&Help'),AT(120,122,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Record Will Be Changed'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateDEPARTMENT2')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?DEP:DEPT_NO:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(DEP1:Record,History::DEP1:Record)
  SELF.AddHistoryField(?DEP1:DEPT_NO,1)
  SELF.AddHistoryField(?DEP1:DEPARTMENT,2)
  SELF.AddHistoryField(?DEP1:HEAD_DEPT,3)
  SELF.AddHistoryField(?DEP1:MNGR_NO,4)
  SELF.AddHistoryField(?DEP1:BUDGET,5)
  SELF.AddHistoryField(?DEP1:LOCATION,6)
  SELF.AddHistoryField(?DEP1:PHONE_NO,7)
  SELF.AddUpdateFile(Access:DEPARTMENT2)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:DEPARTMENT2.Open                                  ! File DEPARTMENT2 used by this procedure, so make sure it's RelationManager is open
  Relate:EMPLOYEE.Open                                     ! File EMPLOYEE used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:DEPARTMENT2
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF SELF.Request = ViewRecord                             ! Configure controls for View Only mode
    ?DEP1:DEPT_NO{PROP:ReadOnly} = True
    ?DEP1:DEPARTMENT{PROP:ReadOnly} = True
    ?DEP1:HEAD_DEPT{PROP:ReadOnly} = True
    ?DEP1:MNGR_NO{PROP:ReadOnly} = True
    ?DEP1:BUDGET{PROP:ReadOnly} = True
    ?DEP1:LOCATION{PROP:ReadOnly} = True
    ?DEP1:PHONE_NO{PROP:ReadOnly} = True
  END
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdateDEPARTMENT2',QuickWindow)            ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:DEPARTMENT2.Close
    Relate:EMPLOYEE.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateDEPARTMENT2',QuickWindow)         ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    EXECUTE Number
      SelectDEPARTMENT2
      SelectEMPLOYEE
    END
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?DEP1:HEAD_DEPT
      IF Access:DEPARTMENT2.TryValidateField(3)            ! Attempt to validate DEP1:HEAD_DEPT in DEPARTMENT2
        SELECT(?DEP1:HEAD_DEPT)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?DEP1:HEAD_DEPT
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?DEP1:HEAD_DEPT{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?DEP1:MNGR_NO
      IF Access:DEPARTMENT2.TryValidateField(4)            ! Attempt to validate DEP1:MNGR_NO in DEPARTMENT2
        SELECT(?DEP1:MNGR_NO)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?DEP1:MNGR_NO
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?DEP1:MNGR_NO{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Form DEPARTMENT3
!!! </summary>
UpdateDEPARTMENT3 PROCEDURE 

CurrentTab           STRING(80)                            !
ActionMessage        CSTRING(40)                           !
History::DEP2:Record LIKE(DEP2:RECORD),THREAD
QuickWindow          WINDOW('Form DEPARTMENT3'),AT(,,232,182),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('UpdateDEPARTMENT3'),SYSTEM
                       SHEET,AT(4,4,224,156),USE(?CurrentTab)
                         TAB('&1) General'),USE(?Tab:1)
                           PROMPT('EMP NO:'),AT(8,20),USE(?EMP:EMP_NO:Prompt),TRN
                           ENTRY(@n-7),AT(72,20,40,10),USE(DEP2:EMP_NO)
                           PROMPT('FIRST NAME:'),AT(8,34),USE(?EMP:FIRST_NAME:Prompt),TRN
                           ENTRY(@s15),AT(72,34,64,10),USE(DEP2:FIRST_NAME)
                           PROMPT('LAST NAME:'),AT(8,48),USE(?EMP:LAST_NAME:Prompt),TRN
                           ENTRY(@s20),AT(72,48,84,10),USE(DEP2:LAST_NAME)
                           PROMPT('PHONE EXT:'),AT(8,62),USE(?EMP:PHONE_EXT:Prompt),TRN
                           ENTRY(@s4),AT(72,62,40,10),USE(DEP2:PHONE_EXT)
                           PROMPT('HIRE DATE DATE:'),AT(8,76),USE(?EMP:HIRE_DATE_DATE:Prompt),TRN
                           ENTRY(@d17),AT(72,76,104,10),USE(DEP2:HIRE_DATE_DATE)
                           PROMPT('HIRE DATE TIME:'),AT(8,90),USE(?EMP:HIRE_DATE_TIME:Prompt),TRN
                           ENTRY(@t7),AT(72,90,104,10),USE(DEP2:HIRE_DATE_TIME)
                           PROMPT('DEPT NO:'),AT(8,104),USE(?EMP:DEPT_NO:Prompt),TRN
                           ENTRY(@s3),AT(72,104,40,10),USE(DEP2:DEPT_NO)
                           PROMPT('JOB CODE:'),AT(8,118),USE(?EMP:JOB_CODE:Prompt),TRN
                           ENTRY(@s5),AT(72,118,40,10),USE(DEP2:JOB_CODE)
                           PROMPT('JOB GRADE:'),AT(8,132),USE(?EMP:JOB_GRADE:Prompt),TRN
                           ENTRY(@n-7),AT(72,132,40,10),USE(DEP2:JOB_GRADE)
                           PROMPT('JOB COUNTRY:'),AT(8,146),USE(?EMP:JOB_COUNTRY:Prompt),TRN
                           ENTRY(@s15),AT(72,146,64,10),USE(DEP2:JOB_COUNTRY)
                         END
                         TAB('&2) General (cont.)'),USE(?Tab:2)
                           PROMPT('SALARY:'),AT(8,20),USE(?EMP:SALARY:Prompt),TRN
                           ENTRY(@n-14.2),AT(72,20,64,10),USE(DEP2:SALARY)
                           PROMPT('FULL NAME:'),AT(8,34),USE(?EMP:FULL_NAME:Prompt),TRN
                           ENTRY(@s37),AT(72,34,152,10),USE(DEP2:FULL_NAME)
                         END
                       END
                       BUTTON('&OK'),AT(73,164,49,14),USE(?OK),LEFT,ICON('WAOK.ICO'),DEFAULT,FLAT,MSG('Accept dat' & |
  'a and close the window'),TIP('Accept data and close the window')
                       BUTTON('&Cancel'),AT(126,164,49,14),USE(?Cancel),LEFT,ICON('WACANCEL.ICO'),FLAT,MSG('Cancel operation'), |
  TIP('Cancel operation')
                       BUTTON('&Help'),AT(179,164,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Record Will Be Changed'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateDEPARTMENT3')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?EMP:EMP_NO:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(DEP2:Record,History::DEP2:Record)
  SELF.AddHistoryField(?DEP2:EMP_NO,1)
  SELF.AddHistoryField(?DEP2:FIRST_NAME,2)
  SELF.AddHistoryField(?DEP2:LAST_NAME,3)
  SELF.AddHistoryField(?DEP2:PHONE_EXT,4)
  SELF.AddHistoryField(?DEP2:HIRE_DATE_DATE,7)
  SELF.AddHistoryField(?DEP2:HIRE_DATE_TIME,8)
  SELF.AddHistoryField(?DEP2:DEPT_NO,9)
  SELF.AddHistoryField(?DEP2:JOB_CODE,10)
  SELF.AddHistoryField(?DEP2:JOB_GRADE,11)
  SELF.AddHistoryField(?DEP2:JOB_COUNTRY,12)
  SELF.AddHistoryField(?DEP2:SALARY,13)
  SELF.AddHistoryField(?DEP2:FULL_NAME,14)
  SELF.AddUpdateFile(Access:DEPARTMENT3)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:DEPARTMENT.Open                                   ! File DEPARTMENT used by this procedure, so make sure it's RelationManager is open
  Relate:DEPARTMENT3.Open                                  ! File DEPARTMENT3 used by this procedure, so make sure it's RelationManager is open
  Relate:JOB.Open                                          ! File JOB used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:DEPARTMENT3
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF SELF.Request = ViewRecord                             ! Configure controls for View Only mode
    ?DEP2:EMP_NO{PROP:ReadOnly} = True
    ?DEP2:FIRST_NAME{PROP:ReadOnly} = True
    ?DEP2:LAST_NAME{PROP:ReadOnly} = True
    ?DEP2:PHONE_EXT{PROP:ReadOnly} = True
    ?DEP2:HIRE_DATE_DATE{PROP:ReadOnly} = True
    ?DEP2:HIRE_DATE_TIME{PROP:ReadOnly} = True
    ?DEP2:DEPT_NO{PROP:ReadOnly} = True
    ?DEP2:JOB_CODE{PROP:ReadOnly} = True
    ?DEP2:JOB_GRADE{PROP:ReadOnly} = True
    ?DEP2:JOB_COUNTRY{PROP:ReadOnly} = True
    ?DEP2:SALARY{PROP:ReadOnly} = True
    ?DEP2:FULL_NAME{PROP:ReadOnly} = True
  END
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdateDEPARTMENT3',QuickWindow)            ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:DEPARTMENT.Close
    Relate:DEPARTMENT3.Close
    Relate:JOB.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateDEPARTMENT3',QuickWindow)         ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    EXECUTE Number
      SelectDEPARTMENT
      SelectJOB
      SelectJOB
      SelectJOB
    END
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?DEP2:DEPT_NO
      IF Access:DEPARTMENT3.TryValidateField(9)            ! Attempt to validate DEP2:DEPT_NO in DEPARTMENT3
        SELECT(?DEP2:DEPT_NO)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?DEP2:DEPT_NO
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?DEP2:DEPT_NO{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?DEP2:JOB_CODE
      IF Access:DEPARTMENT3.TryValidateField(10)           ! Attempt to validate DEP2:JOB_CODE in DEPARTMENT3
        SELECT(?DEP2:JOB_CODE)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?DEP2:JOB_CODE
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?DEP2:JOB_CODE{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?DEP2:JOB_GRADE
      IF Access:DEPARTMENT3.TryValidateField(11)           ! Attempt to validate DEP2:JOB_GRADE in DEPARTMENT3
        SELECT(?DEP2:JOB_GRADE)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?DEP2:JOB_GRADE
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?DEP2:JOB_GRADE{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?DEP2:JOB_COUNTRY
      IF Access:DEPARTMENT3.TryValidateField(12)           ! Attempt to validate DEP2:JOB_COUNTRY in DEPARTMENT3
        SELECT(?DEP2:JOB_COUNTRY)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?DEP2:JOB_COUNTRY
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?DEP2:JOB_COUNTRY{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

